(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.0'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     21843,        433]*)
(*NotebookOutlinePosition[     22487,        455]*)
(*  CellTagsIndexPosition[     22443,        451]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["\<\
Cholesky decomposition of the matrix m:
m = Transpose[u].u, u upper left triangular\
\>", "Subtitle"],

Cell[BoxData[{
    \(\(rootDir\  = \ \
"\<D:\\DATADIR\Programmazione\java\joptimizer\\src\\test\\resources\\\
factorization\\\>";\)\), "\[IndentingNewLine]", 
    \(\(problemId\  = \ "\<10\>";\)\)}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      StyleBox["n",
        "MR"], 
      StyleBox["=",
        "MR"], 
      RowBox[{
        RowBox[{
          StyleBox["Import",
            "MR"], 
          StyleBox["[",
            "MR"], 
          RowBox[{
            RowBox[{"rootDir", " ", "<>", 
              StyleBox["\"\<n\>\"",
                "MR"], 
              StyleBox[" ",
                "MR"], 
              StyleBox["<>",
                "MR"], "problemId", "<>", " ", 
              StyleBox["\"\<.txt\>\"",
                "MR"]}], 
            StyleBox[",",
              "MR"], " ", Cell[BoxData[
                FormBox[
                  StyleBox["\"\<List\>\"",
                    "MR"], TraditionalForm]]]}], 
          StyleBox["]",
            "MR"]}], 
        StyleBox["[",
          "MR"], 
        StyleBox[\([1]\),
          "MR"], 
        StyleBox["]",
          "MR"]}]}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"A", "=", 
        RowBox[{"ReadList", "[", 
          RowBox[{
            RowBox[{"rootDir", " ", "<>", " ", 
              StyleBox["\"\<matrix\>\"",
                "MR"], 
              StyleBox["<>",
                "MR"], 
              StyleBox["problemId",
                "MR"], 
              StyleBox["<>",
                "MR"], 
              StyleBox["\"\<.txt\>\"",
                "MR"]}], ",", \(Table[Number, {n}]\)}], "]"}]}], 
      ";"}]}], "Input"],

Cell[BoxData[
    \(761\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(u = CholeskyDecomposition[A];\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"Norm", 
      StyleBox["[",
        "MR"], 
      RowBox[{
        RowBox[{
          RowBox[{
            StyleBox["Transpose",
              "MR"], 
            StyleBox["[",
              "MR"], 
            StyleBox["u",
              "TI"], 
            StyleBox["]",
              "MR"]}], 
          StyleBox[".",
            "MR"], 
          StyleBox["u",
            "MR"]}], 
        StyleBox[" ",
          "MR"], 
        StyleBox["-",
          "MR"], 
        StyleBox[" ",
          "MR"], 
        StyleBox["A",
          "MR"]}], 
      StyleBox["]",
        "MR"]}]], "Input"],

Cell[BoxData[
    \(9.100883076042007`*^-13\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Eigenvalues[A]\)], "Input"],

Cell[BoxData[
    \({7820.9340494833705`, 107.1094829441992`, 49.19838078840757`, 
      48.69791574978314`, 30.355331113999927`, 25.285161253868647`, 
      25.183821925268308`, 20.537292967041342`, 20.4810032950605`, 
      18.433619436419423`, 18.39260718598022`, 16.426606386911015`, 
      16.399792800116952`, 15.291780283936605`, 15.285564755215132`, 
      15.276207343445764`, 15.247511582281819`, 15.147234049428908`, 
      15.120713411997537`, 14.819516538557318`, 14.12096531076965`, 
      13.994498455680189`, 13.979910074351137`, 13.794101123403605`, 
      13.779448498616807`, 13.337529324558917`, 13.329862433699992`, 
      13.297287482757012`, 13.287610079246951`, 13.250991364300189`, 
      13.242657422333123`, 13.227779062198449`, 13.204840500625858`, 
      12.853853780261979`, 12.731864331166596`, 12.721448741884965`, 
      12.43401546571535`, 12.425496969084415`, 12.142123184229744`, 
      12.135481698566588`, 12.005686516340555`, 11.916341407853823`, 
      11.911809362125046`, 11.880298451231733`, 11.866837143363531`, 
      11.862169098286882`, 11.845998169591914`, 11.840393228463844`, 
      11.825232256832978`, 11.816352278398098`, 11.697817062334105`, 
      11.69344134133071`, 11.663278394098539`, 11.658980824432453`, 
      11.629663596167342`, 11.629217584205419`, 11.628696757836474`, 
      11.625991810091863`, 11.624023843350193`, 11.607468178444`, 
      11.429191247698016`, 11.427645875375903`, 11.425182831930284`, 
      11.418852272350597`, 11.375055222507358`, 11.37250231873672`, 
      11.364446447046385`, 11.362198465439358`, 11.356942046641999`, 
      11.349434169679084`, 11.343522393269941`, 11.331325043087018`, 
      11.254370732508379`, 11.250054768651568`, 11.205598816094538`, 
      11.202875385574533`, 11.195708473139954`, 11.15648491237255`, 
      11.153367633490125`, 11.139333408927024`, 11.136203889737937`, 
      11.128537820101355`, 11.122796041262974`, 11.087538221954384`, 
      11.083772155736666`, 11.060478866978572`, 11.058891296829602`, 
      11.056590866438887`, 11.049152464660702`, 11.016807115920598`, 
      11.011893520042358`, 10.923639049284423`, 10.921009031739148`, 
      10.900799501495444`, 10.898271554514265`, 10.879514644639164`, 
      10.8791367044629`, 10.878698691488824`, 10.874725347499774`, 
      10.8690488390168`, 10.864050730768353`, 10.838828493652068`, 
      10.836457977244093`, 10.829665593270496`, 10.826644875281003`, 
      10.82079833562919`, 10.814747352129084`, 10.766558715150532`, 
      10.715786917125106`, 10.714444687377336`, 10.710890130287064`, 
      10.698767961819206`, 10.697925313440619`, 10.69669314489571`, 
      10.692896793534073`, 10.678920278217804`, 10.676300002780037`, 
      10.654133295116429`, 10.652423469275904`, 10.643677486585952`, 
      10.641935841286857`, 10.633106747558587`, 10.631748625246649`, 
      10.626218171423806`, 10.625925813634488`, 10.625593956415221`, 
      10.62260914901738`, 10.618052799325751`, 10.61631039956224`, 
      10.613638011970748`, 10.610865353744808`, 10.607316479056708`, 
      10.602347191904064`, 10.58828509407852`, 10.58540085253768`, 
      10.567965784051`, 10.566624719096714`, 10.563428833737996`, 
      10.561283705349707`, 10.55656436800531`, 10.5480618384862`, 
      10.547027871515708`, 10.545310095244341`, 10.54322704001955`, 
      10.539532657821441`, 10.533213986707251`, 10.532845934868659`, 
      10.53246302330867`, 10.525277624953853`, 10.512694569782939`, 
      10.509001448373828`, 10.487798877377147`, 10.485633904534156`, 
      10.474052805034004`, 10.472252131038276`, 10.465690726856247`, 
      10.46360670085234`, 10.452327335275625`, 10.449586177149738`, 
      10.44858295413554`, 10.445919371998778`, 10.444914139161083`, 
      10.444086845324163`, 10.442773595809458`, 10.440845917060509`, 
      10.440562370356071`, 10.44029314439346`, 10.436445909836161`, 
      10.434547161949466`, 10.424931743895401`, 10.398670885381604`, 
      10.398604705448212`, 10.398536988499183`, 10.393930321569956`, 
      10.385356378263774`, 10.382488362770667`, 10.37533488083289`, 
      10.371506302658767`, 10.339073194307284`, 10.33805509490559`, 
      10.33594336868232`, 10.333459505694526`, 10.321549068428448`, 
      10.319907871604505`, 10.310036431831433`, 10.308977568769363`, 
      10.305746360299198`, 10.30457488101627`, 10.302104578978058`, 
      10.300438157684356`, 10.296138768294966`, 10.295733238920603`, 
      10.295288648582853`, 10.29112977531666`, 10.282961654235303`, 
      10.282305168943955`, 10.278904369237909`, 10.269339902437986`, 
      10.267113571131663`, 10.25099345931511`, 10.250421929398206`, 
      10.249198161706245`, 10.248681201815858`, 10.248136607807941`, 
      10.2444006960132`, 10.229956419395046`, 10.229422608389571`, 
      10.228329579257869`, 10.228095294604275`, 10.225612400777505`, 
      10.22016766862003`, 10.219075738098807`, 10.217032883322227`, 
      10.214960303814427`, 10.207728121281336`, 10.207426347872575`, 
      10.207071021390663`, 10.204522672562147`, 10.198547647207425`, 
      10.198244614267695`, 10.197901095714547`, 10.194970024681817`, 
      10.190196964363912`, 10.188248558376182`, 10.18014843273709`, 
      10.179589450130726`, 10.17869431603678`, 10.177305705733348`, 
      10.175445140160265`, 10.173156635643574`, 10.166368885884795`, 
      10.165523410285177`, 10.163521858497406`, 10.162784423099561`, 
      10.16183887828908`, 10.159552896871999`, 10.154553895622136`, 
      10.153984399298439`, 10.153222825698718`, 10.151205984146744`, 
      10.14806169599934`, 10.145467905514014`, 10.144311674649773`, 
      10.14180771016529`, 10.141739700789264`, 10.139591553106088`, 
      10.136585529403634`, 10.135357041069083`, 10.13238850201441`, 
      10.132378784537673`, 10.13236904061292`, 10.13045510552048`, 
      10.129326761104837`, 10.126342345066744`, 10.123985481534886`, 
      10.120640993198146`, 10.11486057506267`, 10.11388336049851`, 
      10.11251302386807`, 10.11026650014115`, 10.107266099954716`, 
      10.105062894286663`, 10.099602192260482`, 10.09937846312233`, 
      10.098040933474165`, 10.095858008717856`, 10.095419654601569`, 
      10.094885586788495`, 10.094271345352889`, 10.093848300599136`, 
      10.086269718369442`, 10.073577825027476`, 10.073197184086984`, 
      10.072512811502376`, 10.072086539766643`, 10.071671737170318`, 
      10.069470913445228`, 10.06733755270844`, 10.065693780195888`, 
      10.062782338887027`, 10.062250459615045`, 10.061505019890093`, 
      10.061059442190844`, 10.060703625227168`, 10.057090644918551`, 
      10.05552254567874`, 10.048782663152652`, 10.041421623758009`, 
      10.039241281713652`, 10.033242646613528`, 10.033222688615355`, 
      10.031678225262555`, 10.030197662040878`, 10.028275417908686`, 
      10.026702440533464`, 10.020613257872563`, 10.005018486696523`, 
      10.002742957653878`, 10.001465901954463`, 9.996727620652505`, 
      9.996051508197953`, 9.994359492164305`, 9.99415956308401`, 
      9.993953075266065`, 9.991119092005603`, 9.987548028556139`, 
      9.986081823499985`, 9.983141926045386`, 9.981841192678145`, 
      9.97898430717885`, 9.978652100665952`, 9.978303574880007`, 
      9.97489771563795`, 9.970672448447624`, 9.968744732850878`, 
      9.961885746260089`, 9.961634156073382`, 9.961303867755161`, 
      9.960525791540276`, 9.959890884491289`, 9.956762099471826`, 
      9.95145431742724`, 9.950507230308444`, 9.948559095866015`, 
      9.947704268023875`, 9.946661445298465`, 9.944157926542813`, 
      9.938589449295476`, 9.937695392426894`, 9.935654018143564`, 
      9.934672307323689`, 9.932998208563815`, 9.931469700396606`, 
      9.924800920053867`, 9.924752425352986`, 9.924694103757018`, 
      9.924401259619101`, 9.924076347189407`, 9.923994295497012`, 
      9.923679163821314`, 9.923497595662043`, 9.92063324266965`, 
      9.91635914532772`, 9.91630298129361`, 9.916221826469412`, 
      9.916130396532955`, 9.916057068259766`, 9.915511684628202`, 
      9.915219361630063`, 9.914688445845636`, 9.914413169534216`, 
      9.912023628938245`, 9.911216245975647`, 9.907996796367899`, 
      9.906485369757009`, 9.902987117636608`, 9.899506769264873`, 
      9.898124174846027`, 9.895819637955062`, 9.894656303445961`, 
      9.89370723870593`, 9.892654314803204`, 9.891295415755677`, 
      9.889535547801175`, 9.888099539852272`, 9.886700623955631`, 
      9.885294794505965`, 9.883838941470914`, 9.882505785368958`, 
      9.880652726384598`, 9.878880014445501`, 9.87745920311963`, 
      9.875989830563507`, 9.87454965581876`, 9.872898235684714`, 
      9.872488551681894`, 9.872129304469324`, 9.869094883261718`, 
      9.865583483062904`, 9.861703161159133`, 9.861552210316761`, 
      9.861401265249322`, 9.857523896809388`, 9.854020959320243`, 
      9.85099775785883`, 9.8506400657205`, 9.850232234078677`, 
      9.848588850493401`, 9.847156742053633`, 9.845696283981043`, 
      9.84428508771189`, 9.842525275879774`, 9.840687302866671`, 
      9.839365680311426`, 9.837923404282195`, 9.836531330217943`, 
      9.835147047497694`, 9.833726716122813`, 9.831987283229013`, 
      9.830645061561253`, 9.829605473023856`, 9.828668889371384`, 
      9.827521260209851`, 9.825249394299325`, 9.823887575361715`, 
      9.820462251619835`, 9.817024821069174`, 9.81554087780946`, 
      9.812383416455384`, 9.811592136388805`, 9.80925194335339`, 
      9.808982485232177`, 9.808462890603023`, 9.808176840283975`, 
      9.807643263667641`, 9.80757153080277`, 9.807482093744907`, 
      9.807402710114653`, 9.807347773707848`, 9.803170558739568`, 
      9.800375391065666`, 9.800198304719457`, 9.799890987992034`, 
      9.799810977173502`, 9.799494168140294`, 9.799208668871499`, 
      9.79915181328929`, 9.799104538844675`, 9.792612126073495`, 
      9.79112666583003`, 9.789500529069977`, 9.788547548855666`, 
      9.786566923952675`, 9.785700067800617`, 9.780307299629294`, 
      9.777887104751494`, 9.776879540738184`, 9.776053999781352`, 
      9.77417350648055`, 9.773259924471704`, 9.768145598613176`, 
      9.765136439267897`, 9.764526176125768`, 9.763778555847717`, 
      9.763461253475901`, 9.763219589647166`, 9.756640165207747`, 
      9.754794566820562`, 9.750753315007925`, 9.747501353457437`, 
      9.747168781826309`, 9.74685183578306`, 9.74412775258689`, 
      9.742888661296059`, 9.740090054663158`, 9.738695737126891`, 
      9.735302565828027`, 9.732613597394861`, 9.732417773655522`, 
      9.732228188930089`, 9.73062426805402`, 9.729983703283219`, 
      9.725498983850871`, 9.72429185791401`, 9.722142183117777`, 
      9.707460698759286`, 9.701754216854825`, 9.700281876495074`, 
      9.698484115506785`, 9.69710018390633`, 9.695657541392842`, 
      9.695638903826987`, 9.690043437190143`, 9.688013310597357`, 
      9.681170137644871`, 9.674923603395163`, 9.6734722577529`, 
      9.67013215059558`, 9.669803440131242`, 9.669391886453079`, 
      9.668703501210311`, 9.668212479476358`, 9.665526273421099`, 
      9.664011218404996`, 9.662046052871949`, 9.660020724228369`, 
      9.659639159694878`, 9.659247124472829`, 9.658617832539965`, 
      9.658267913944616`, 9.646628708396891`, 9.639707548410842`, 
      9.639321735912423`, 9.638761691323557`, 9.638274836257471`, 
      9.6378753262063`, 9.635886723878412`, 9.63466921044993`, 
      9.634465607415228`, 9.629501290000631`, 9.62750169128603`, 
      9.624780736192816`, 9.62274588021751`, 9.621505340288584`, 
      9.620621177328433`, 9.615397234685839`, 9.612380724353995`, 
      9.61025679256378`, 9.607570583843335`, 9.606555645953106`, 
      9.604835245614746`, 9.604826489909124`, 9.60481775801003`, 
      9.60215173653956`, 9.601049452404387`, 9.598354064676831`, 
      9.596430078364387`, 9.596369186868829`, 9.594128310159343`, 
      9.59309440424497`, 9.59077644692629`, 9.587969613317826`, 
      9.586171230449326`, 9.585492429877528`, 9.584984990015387`, 
      9.580535084863262`, 9.578503356640907`, 9.577663377542299`, 
      9.577008532824403`, 9.575231957303666`, 9.57448198969478`, 
      9.568469123556541`, 9.566445742773`, 9.564801719093486`, 
      9.563575632121`, 9.562785534727235`, 9.562292310851129`, 
      9.555156342613577`, 9.553443439783694`, 9.549251755936465`, 
      9.546681945344135`, 9.546380914243107`, 9.546115402017792`, 
      9.540886089258377`, 9.53865974147683`, 9.538349444976442`, 
      9.538085955733772`, 9.53177993187723`, 9.529976262314209`, 
      9.52819953238956`, 9.527250522527092`, 9.522523687629983`, 
      9.520371734042667`, 9.520168760421859`, 9.5192220217639`, 
      9.518759823995088`, 9.506287595073692`, 9.503073393029686`, 
      9.502605143903244`, 9.502160765194107`, 9.501109112124913`, 
      9.50061815980733`, 9.486813144623065`, 9.484913496433604`, 
      9.476768451473964`, 9.473880073249523`, 9.473322842741704`, 
      9.466400353234421`, 9.462884625382008`, 9.462509045610703`, 
      9.46216653137189`, 9.458538177643115`, 9.45713362051094`, 
      9.455052800903742`, 9.454066812050678`, 9.451349156225865`, 
      9.450459394020138`, 9.442180358672575`, 9.440807072990813`, 
      9.430864161402196`, 9.42879657697105`, 9.427039883174158`, 
      9.426193535847021`, 9.399394690837282`, 9.396253291947021`, 
      9.390393418595933`, 9.388049036823078`, 9.381053087933287`, 
      9.377304313621417`, 9.377249244917389`, 9.377195427790818`, 
      9.355940388708978`, 9.348211487923512`, 9.346687875437707`, 
      9.343604458672916`, 9.343388830866322`, 9.343161761759534`, 
      9.341618582438821`, 9.340567998037875`, 9.339906377773042`, 
      9.339102738665277`, 9.336974682156283`, 9.336173770190877`, 
      9.333986692343453`, 9.325009958475894`, 9.323355696106338`, 
      9.31815444199591`, 9.316729453916063`, 9.307585051626974`, 
      9.305880185432537`, 9.289249815889209`, 9.286366957836227`, 
      9.276569162035559`, 9.270995999657897`, 9.270699332953848`, 
      9.27041422680268`, 9.26552500739349`, 9.262671825723755`, 
      9.261064789463274`, 9.259740283316978`, 9.258943508263085`, 
      9.25240191162314`, 9.248779645286474`, 9.24713540804168`, 
      9.244687656677856`, 9.243661494832184`, 9.230362959758393`, 
      9.228171487566426`, 9.21751554228817`, 9.213763876497376`, 
      9.21108763141106`, 9.20899954320714`, 9.206988509241077`, 
      9.20567854306041`, 9.202256212018666`, 9.200017657731324`, 
      9.19976888523327`, 9.199549752936361`, 9.195408555182288`, 
      9.194392954055617`, 9.187801491763564`, 9.186503866180223`, 
      9.179998478970605`, 9.17872922043482`, 9.162339858961866`, 
      9.160411318358621`, 9.150151402893302`, 9.147373887847401`, 
      9.146472968730675`, 9.145857126267932`, 9.137016970175653`, 
      9.134431989173487`, 9.133456756097603`, 9.096892795446083`, 
      9.062771699794515`, 9.058528438444919`, 9.054434822396955`, 
      9.05232356827542`, 9.047582910970856`, 9.045931389205512`, 
      9.028436862475514`, 9.024989034503333`, 9.021078629378243`, 
      9.018346622773356`, 9.018045626055743`, 9.017785954991643`, 
      9.004939405065214`, 9.003214585024269`, 8.989474830677233`, 
      8.987694014281422`, 8.928815252035996`, 8.925588645870159`, 
      8.904467857146988`, 8.899644566318868`, 8.898154604863665`, 
      8.89712715832732`, 8.88211112355179`, 8.879694797117379`, 
      8.857207981335778`, 8.853571805152276`, 8.848725244065244`, 
      8.846750753601805`, 8.837918342439988`, 8.835962447442084`, 
      8.811511977803093`, 8.807078137026744`, 8.8053960147536`, 
      8.778137301654569`, 8.775512277813315`, 8.72928438738865`, 
      8.722060789791454`, 8.718569871487544`, 8.71414397020292`, 
      8.711052186183453`, 8.709731462366966`, 8.705005330476956`, 
      8.703510426913615`, 8.678041761081497`, 8.674390268523814`, 
      8.672970942451892`, 8.672081095946945`, 8.57217838704406`, 
      8.563176093328012`, 8.562108313096926`, 8.5606418897439`, 
      8.560359650841292`, 8.56011799777214`, 8.54430295369938`, 
      8.541997009601149`, 8.525889462413497`, 8.523565502901468`, 
      8.461713107500982`, 8.457167813247862`, 8.449429301321432`, 
      8.44657831346336`, 8.43837525510864`, 8.43601529944163`, 
      8.429225350924296`, 8.413433637651773`, 8.411174892022997`, 
      8.367222312984444`, 8.305312713884577`, 8.302206260788799`, 
      8.17473113513426`, 8.171050316980955`, 8.051499140453766`, 
      8.047335269832212`, 7.999349169278861`, 7.8691729488035405`, 
      7.861057452672546`, 7.855811126222293`, 7.852882354582078`, 
      7.840076297714352`, 7.836712869960297`, 7.825441384340523`, 
      7.822802595147194`, 7.6783657001310415`, 7.673827156016402`, 
      7.6174997283198485`, 7.613178772097359`, 7.5762645802338655`, 
      7.389382890617436`, 7.316706000134251`, 7.310519959466906`, 
      7.287383106413015`, 7.280852428292175`, 7.2787284192244135`, 
      7.277320183917589`, 7.050616698970772`, 7.0456779791503195`, 
      6.736803915097009`, 6.731326730682794`, 6.494251363992796`, 
      6.488622306342287`, 6.131200630295168`, 6.125238764218488`, 
      5.887029302987467`, 5.486238708332228`, 5.479993827439478`, 
      5.168676637001801`, 1.6904012911656`*^-14}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Det[A]\)], "Input"],

Cell[BoxData[
    \(8.1825659097288853509256119`15.954589770191005*^748\)], "Output"]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"5.0 for Microsoft Windows",
ScreenRectangle->{{0, 1920}, {0, 991}},
WindowSize->{1912, 958},
WindowMargins->{{0, Automatic}, {Automatic, 0}}
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 111, 3, 80, "Subtitle"],
Cell[1890, 58, 208, 4, 50, "Input"],

Cell[CellGroupData[{
Cell[2123, 66, 1420, 50, 51, "Input"],
Cell[3546, 118, 37, 1, 29, "Output"]
}, Open  ]],
Cell[3598, 122, 66, 1, 30, "Input"],

Cell[CellGroupData[{
Cell[3689, 127, 622, 28, 30, "Input"],
Cell[4314, 157, 57, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4408, 163, 47, 1, 30, "Input"],
Cell[4458, 166, 17193, 254, 542, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[21688, 425, 39, 1, 30, "Input"],
Cell[21730, 428, 85, 1, 29, "Output"]
}, Open  ]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

