(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.0'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     46939,        870]*)
(*NotebookOutlinePosition[     47583,        892]*)
(*  CellTagsIndexPosition[     47539,        888]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["\<\
Solves the LP problem defined by:
min(c) s.t.
A.x = b
lb <= x <= ub\
\>", "Subtitle"],

Cell[BoxData[{
    \(\(rootDir\  = \ \
"\<D:\\DATADIR\Programmazione\java\joptimizer\\src\\test\\resources\\lp\\\>";\
\)\), "\[IndentingNewLine]", 
    \(\(problemId\  = \ "\<12\>";\)\)}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{
        StyleBox["c",
          "MR"], 
        StyleBox["=",
          "MR"], 
        RowBox[{
          StyleBox["Import",
            "MR"], 
          StyleBox["[",
            "MR"], 
          RowBox[{
            RowBox[{"rootDir", " ", "<>", 
              StyleBox["\"\<c\>\"",
                "MR"], 
              StyleBox[" ",
                "MR"], 
              StyleBox["<>",
                "MR"], "problemId", "<>", " ", 
              StyleBox["\"\<.txt\>\"",
                "MR"]}], 
            StyleBox[",",
              "MR"], " ", Cell[BoxData[
                FormBox[
                  StyleBox["\"\<List\>\"",
                    "MR"], TraditionalForm]]]}], 
          StyleBox["]",
            "MR"]}]}], 
      StyleBox[";",
        "MR"]}], "\[IndentingNewLine]", \(n = 
        Length[c];\), "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"A", "=", 
        RowBox[{"ReadList", "[", 
          RowBox[{
            RowBox[{"rootDir", " ", "<>", " ", 
              StyleBox["\"\<A\>\"",
                "MR"], 
              StyleBox["<>",
                "MR"], 
              StyleBox["problemId",
                "MR"], 
              StyleBox["<>",
                "MR"], 
              StyleBox["\"\<.txt\>\"",
                "MR"]}], ",", \(Table[Number, {n}]\)}], "]"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{
        StyleBox["b",
          "MR"], 
        StyleBox["=",
          "MR"], 
        RowBox[{"ReadList", "[", 
          RowBox[{
            RowBox[{"rootDir", " ", "<>", " ", 
              StyleBox["\"\<b\>\"",
                "MR"], 
              StyleBox["<>",
                "MR"], 
              StyleBox["problemId",
                "MR"], 
              StyleBox["<>",
                "MR"], 
              StyleBox["\"\<.txt\>\"",
                "MR"]}], ",", "Number"}], "]"}]}], 
      ";"}], "\[IndentingNewLine]", \(bCoeff\  = \ 
        Table[{b[\([i]\)], 0}, \ {i, Length[b]}];\), "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{
        StyleBox["lb",
          "MR"], 
        StyleBox["=",
          "MR"], 
        RowBox[{
          RowBox[{
            StyleBox["Import",
              "MR"], 
            StyleBox["[",
              "MR"], 
            RowBox[{
              RowBox[{"rootDir", " ", "<>", " ", 
                StyleBox["\"\<lb\>\"",
                  "MR"], 
                StyleBox["<>",
                  "MR"], 
                StyleBox["problemId",
                  "MR"], 
                StyleBox["<>",
                  "MR"], 
                StyleBox["\"\<.txt\>\"",
                  "MR"]}], 
              StyleBox[",",
                "MR"], " ", Cell[BoxData[
                  FormBox[
                    StyleBox["\"\<List\>\"",
                      "MR"], TraditionalForm]]]}], 
            StyleBox["]",
              "MR"]}], "/.", \({"\<NaN\>" \[Rule] 9999999}\)}]}], 
      StyleBox[";",
        "MR"]}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{
        StyleBox["ub",
          "MR"], 
        StyleBox["=",
          "MR"], 
        RowBox[{
          RowBox[{
            StyleBox["Import",
              "MR"], 
            StyleBox["[",
              "MR"], 
            RowBox[{
              RowBox[{"rootDir", " ", "<>", " ", 
                StyleBox["\"\<ub\>\"",
                  "MR"], 
                StyleBox["<>",
                  "MR"], 
                StyleBox["problemId",
                  "MR"], 
                StyleBox["<>",
                  "MR"], 
                StyleBox["\"\<.txt\>\"",
                  "MR"]}], 
              StyleBox[",",
                "MR"], " ", Cell[BoxData[
                  FormBox[
                    StyleBox["\"\<List\>\"",
                      "MR"], TraditionalForm]]]}], 
            StyleBox["]",
              "MR"]}], "/.", 
          RowBox[{"{", 
            RowBox[{"\"\<NaN\>\"", "\[Rule]", 
              RowBox[{"+", 
                StyleBox["99999999",
                  "MR"]}]}], "}"}]}]}], 
      ";"}], "\[IndentingNewLine]", \(variablesBounds\  = \ 
        Table[{lb[\([i]\)], \ ub[\([i]\)]}, \ {i, 
            n}];\), "\[IndentingNewLine]", "n"}], "Input"],

Cell[BoxData[
    \(1488\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(mySol = 
      LinearProgramming[c, A, bCoeff, \ 
        variablesBounds]\), "\[IndentingNewLine]", 
    \(myValue\  = \ c . mySol\), "\[IndentingNewLine]", 
    \(myTolerance\  = \ Norm[A . mySol\  - \ b]\)}], "Input"],

Cell[BoxData[
    \({1.1043219250389857`*^-15, 7.99685200028991`*^-6, 0.15119989562490246`, 
      1.8554557790424052`*^-10, 1.5273080972704744`*^-8, 299.9999970585874`, 
      5.751652751638213`*^-15, 6.999999882738227`, 3.730348394287872`, 
      5.711881511875929`*^-15, 2.9157679922616007`, 0.35786316931753753`, 
      4.243190795403002`*^-9, 0.1541715850078634`, 0.0067209993666609655`, 
      9.032625391577086`*^-10, 2136.0419802643196`, 2206.895989828909`, 
      2236.0712740008407`, 2825.8271355430857`, 2852.9184416732314`, 
      424.3295381911633`, 1267.2828232144084`, 1892.2204469068454`, 
      1112.2001285306296`, 89.60951561603417`, 4678.449201271124`, 
      2840.4147814327694`, 5.752506890988117`*^-15, 41.678842589035554`, 
      5853.796862991581`, 0.00015218409116936338`, 4.64669823124639`*^-6, 
      0.000015876269576367693`, 0.000012290971524001851`, 
      0.000014548256901766431`, 0.000014944531858021516`, 
      0.00001261770436302562`, 0.00001597483512259302`, 
      0.00030069078393676896`, 0.0005399707210232418`, 
      0.00001244795510209199`, 0.0002547389065561522`, 
      0.00002234972224986957`, 0.000017287875081548184`, 
      0.000013317990001831593`, 2.2320458330401465`*^-16, 
      0.00001252996117898455`, 0.000011989165031334745`, 4806.118189381879`, 
      9022.816400529675`, 280.84983191513936`, 0.00006683544320282373`, 
      8.962590429081169`*^-6, 0.00006008183632078348`, 
      0.00006843246217476829`, 0.0001338660341162947`, 118.50595321005488`, 
      1629.7912017933158`, 0.00004975721803105555`, 165.54752858775169`, 
      85.14172251996476`, 1471.4063863342215`, 2.232036589217426`*^-16, 
      1803.6742927835485`, 3398.204341508828`, 53.49520074320181`, 
      1.397871492432319`*^-15, 2.5053718778828744`*^-15, 
      5.050327548616698`*^-16, 2.24473786154182`*^-16, 
      7.69966923145806`*^-16, 3.661718902934269`*^-16, 
      2.6830637784442174`*^-7, 7.72907868369489`*^-16, 
      6.053914650098674`*^-11, 1.8396469088424786`*^-11, 
      1.3788293918535553`*^-11, 5.103197644421147`*^-9, 
      2.2379018016017344`*^-9, 7.701112868576294`*^-16, 
      1.9237404498586302`*^-10, 1.3278479352930967`*^-10, 
      7.702302097285441`*^-16, 3.554254999968247`, 0.436233999976526`, 
      1.0213369999791828`, 0.1879329999801406`, 4.088802612752456`*^-11, 
      6.866464883237582`*^-12, 2229.086910713099`, 1.7863699130755528`*^-6, 
      5.675810997645629`*^-7, 2948.919184146344`, 1.5559378890980715`*^-6, 
      4.968786033195777`*^-7, 3.9818745345760443`*^-7, 1974.6447729419854`, 
      1648.4370080259912`, 93.51290573912902`, 4882.242184295194`, 
      1103.3794618239765`, 5.752506891138114`*^-15, 43.49436901186815`, 
      6108.7812487519`, 2011.6149870900165`, 3581.762446703078`, 
      0.00001498417242752246`, 2595.877490024`, 784.8994128589222`, 
      5838.316405405104`, 7.529088002071547`*^-6, 1257.5092755964342`, 
      622.9096674649887`, 2197.718749589967`, 2.2954539231745516`*^-6, 
      0.00003258051224640842`, 4.691453538124672`*^-6, 
      4.452770852158476`*^-6, 4358.69531073076`, 2.2320312888845434`*^-16, 
      1.017106947732348`*^-6, 1.2263261985445803`*^-6, 
      3.7240760707860164`*^-6, 5.329335007368515`*^-6, 342.3495986955589`, 
      1347.5571279436642`, 427.48168824864564`, 1769.879394576853`, 
      967.0659167334157`, 381.40307529145736`, 144.45614563615496`, 
      1986.6791986391538`, 285.6818824250562`, 201.7987505897299`, 
      103.78619216986384`, 1793.6115701645326`, 5.752506891221014`*^-15, 
      2198.6384257051973`, 4142.3320284373085`, 65.209456112357`, 
      3.779731831606477`*^-7, 7.699936493418997`*^-16, 
      3.490959467066353`*^-10, 1.0133024660488178`*^-7, 
      0.019499999967940163`, 1.885195662445867`*^-8, 4.4944155771853865`*^-9, 
      7.703176547809616`*^-16, 5.555484321564314`*^-10, 
      4.221157121129947`*^-11, 7.708257138561958`*^-16, 4.320443999935449`, 
      0.5302719997804479`, 1.241505999845276`, 0.22844599996469833`, 
      4.62529229040294`*^-11, 1.347163039009608`*^-11, 2342.1420887281283`, 
      1186.0667891635662`, 6.749596239431972`*^-6, 3098.4826642941616`, 
      2366.6437892096237`, 1.1088645813958192`*^-6, 7.425342029473744`*^-7, 
      2074.7951646314436`, 1732.0427235709246`, 98.25572037307201`, 
      5129.855467138505`, 3114.478025362993`, 5.7525068974185574`*^-15, 
      45.700316127650744`, 6418.605467644958`, 2113.640379423608`, 
      3763.4226053363363`, 137.10099860222203`, 1.5445245463790541`*^-6, 
      954.0998223465223`, 7096.878897885382`, 1.831529506486973`*^-6, 
      0.000043355460379053586`, 757.1896956906626`, 2671.4794912164766`, 
      1.4354963290829514`*^-6, 1.6310406529245066`*^-6, 
      1.8001972524605571`*^-6, 1.9638383762989205`*^-6, 
      1.6485713713974831`*^-6, 2.2320350369863147`*^-16, 
      9.104741517842042`*^-7, 1.356884677933387`*^-6, 
      1.7114769683548652`*^-6, 1.7697077449968615`*^-6, 
      1.5258611746287696`*^-6, 1638.0490667071542`, 519.6337866737463`, 
      2151.41113160571`, 1175.5356411941377`, 463.62182435433584`, 
      175.59645034516947`, 2414.94628836234`, 347.2660545597964`, 
      245.30035687889966`, 126.15930755685004`, 2180.25927098441`, 
      5.7525068868646335`*^-15, 2672.59762595098`, 0.000017159092565358037`, 
      79.26662790199401`, 7.703498602981091`*^-7, 7.704106342986827`*^-16, 
      5.93301040527173`*^-11, 2.048290963538186`*^-10, 
      5.98292277413253`*^-10, 2.159586628190291`*^-8, 
      4.9884521920693165`*^-9, 7.705242214647662`*^-16, 
      5.318419108019947`*^-10, 5.979223072490104`*^-11, 
      7.707451643846824`*^-16, 5.23561199992476`, 0.6425959998628046`, 
      1.5044839998925434`, 0.27683499995848193`, 4.8024177591016806`*^-11, 
      1.5547563316343783`*^-11, 2452.195799507351`, 2533.537093492226`, 
      6.2251590055619746`*^-6, 3244.0756821536525`, 3275.176988229497`, 
      1.4428764810030823`*^-6, 9.313552086570386`*^-7, 2172.2866195719525`, 
      1813.4287094180686`, 102.87260238313681`, 5370.902342179118`, 
      3260.822751821589`, 2.2320463362266396`*^-16, 47.84770108613493`, 
      6720.207029529916`, 2212.9572733733257`, 3940.260252104289`, 
      143.54316541775216`, 1.9221335102101705`*^-6, 1156.1994185505077`, 
      8600.156243272944`, 2.0254350502155606`*^-6, 0.000019549176838480923`, 
      917.5795883419712`, 3237.35864202459`, 1.514452773561007`*^-6, 
      1.8895112795261847`*^-6, 1.8464006414798398`*^-6, 
      1.9570124901636292`*^-6, 2.1969642005912943`*^-6, 
      2.2320354094584296`*^-16, 9.583288567086086`*^-7, 
      1.4728389212665229`*^-6, 1.8027690828575059`*^-6, 
      2.0452410480170213`*^-6, 1.7627128136362698`*^-6, 1985.0246545169298`, 
      629.7038545588977`, 2607.12792861616`, 1424.5405235110138`, 
      561.8273911599948`, 212.7917172502156`, 2926.485839234809`, 
      420.82491385288284`, 297.2604868920591`, 152.88267924945458`, 
      2642.0869068394345`, 2.2320358220275396`*^-16, 3238.7135975683273`, 
      3784.7458955685324`, 96.05706466638313`, 1.3466534579974154`*^-9, 
      162.63917381688557`, 85.0507972771977`, 0.9323628456651909`, 
      0.7777777778832943`, 0.9999999990254202`, 0.000060749552953982445`, 
      0.000022204555909104177`, 0.00003241716201278413`, 
      0.000052833778328784575`, 0.00003092315265705901`, 
      9.412786929008216`*^-6, 9.805484973774981`*^-6, 
      0.00006445175666093345`, 9.658562816041628`*^-6, 
      0.000020728499205342295`, 0.000026495098586722512`, 
      0.0000446809124982675`, 0.00009324068335269014`, 
      0.00007144635036416152`, 0.00006997851796746624`, 
      9.080936817315028`*^-6, 3.2339120313763196`*^-6, 
      7.020198693497369`*^-6, 0.000010002533051219542`, 1658.816441138504`, 
      25.221482810386902`, 1.6614668557170683`*^-8, 0.6733333333694683`, 
      0.6907433380344272`, 2.3525756977428847`*^-11, 6.33664838099409`*^-7, 
      3.984905302183406`*^-7, 2.9128510945408224`*^-7, 
      6.825541892074558`*^-7, 4.2379839791085744`*^-7, 
      2.675872462134467`*^-7, 2.413659023608175`*^-7, 8.699157378260308`*^-7, 
      6.496971691917498`*^-7, 7.104587782695699`*^-7, 7.244709078918868`*^-7, 
      4.99201143713034`*^-7, 1.2277238776772355`*^-6, 
      1.6745988904386756`*^-6, 1.3258113702932716`*^-6, 
      7.453370526476176`*^-7, 7.040092561364929`*^-7, 5.812653284825746`*^-7, 
      6.371215461388162`*^-7, 2.1873374932910835`*^-6, 56.03169349929275`, 
      4.149541194679958`*^-9, 0.09145157698977194`, 0.5200000001286814`, 
      0.5455820477391778`, 2.2472687412614877`*^-10, 1.3418644117769875`*^-6, 
      6.54604613761757`*^-7, 6.335076968912254`*^-7, 1.16569761783184`*^-6, 
      6.899030940587108`*^-7, 4.247108382335863`*^-7, 3.623065975650398`*^-7, 
      1.4331349770370484`*^-6, 1.2641726741063931`*^-6, 
      1.1476386841702932`*^-6, 1.111111662917553`*^-6, 
      1.292536413920357`*^-6, 1.8481824925553406`*^-6, 3.43997368080106`*^-6, 
      1.5566633355841503`*^-6, 1.2125164783029397`*^-6, 
      1.1915609930331002`*^-6, 1.3210308644573938`*^-6, 
      7.248173108510866`*^-7, 2715.881334895485`, 28.33201763292091`, 
      1102.4354612025081`, 1.0981332412064692`*^-10, 0.2950000001551423`, 
      0.33239831702856`, 1.3914537456853934`*^-10, 1.2050733934338944`*^-6, 
      6.921175055469465`*^-7, 6.439589053327465`*^-7, 
      1.1619704054037812`*^-6, 7.426688912718938`*^-7, 
      4.7333670534287585`*^-7, 4.0916674588313085`*^-7, 
      1.4607881427108127`*^-6, 1.2167926390665944`*^-6, 
      1.2030686477133979`*^-6, 1.1836295739589205`*^-6, 
      1.1379560656622967`*^-6, 1.8031960465973018`*^-6, 
      3.3583338486815376`*^-6, 1.5295323160786104`*^-6, 
      1.2468818206326644`*^-6, 1.151109881828445`*^-6, 
      1.2528056337355692`*^-6, 7.506820440214578`*^-7, 3210.976967102501`, 
      17.128071950376878`, 4.167415453238028`*^-8, 3.218135182017367`*^-8, 
      6.469693313336872`*^-8, 1.1269497440494454`*^-7, 
      6.428917683119915`*^-8, 8.165167349105213`*^-8, 6.733116454624403`*^-8, 
      1.2604842047286152`*^-7, 9.583646931601373`*^-8, 
      1.285415313240334`*^-7, 1.1549844064611843`*^-7, 
      3.365349278551289`*^-8, 4.339328922446781`*^-8, 
      3.5628691714303656`*^-7, 3.0024095302129524`*^-8, 
      7.344174241314826`*^-7, 13.733562004284973`, 108.51178127006696`, 
      608.1462498501087`, 0.11835006501475809`, 1.6375657464992983`*^-15, 
      3.2356977277956718`, 3.1758294594137394`*^-15, 1.4738792291723748`, 
      12.999999968755828`, 4.444715407074146`*^-16, 1.6640786104355887`*^-15, 
      560.3223743185551`, 33.979806568703474`, 1.2757779101732083`*^-7, 
      49.09166013210595`, 2.003147999716191`*^-6, 0.3642281136058462`, 
      0.2554600591969916`, 0.3296600762915664`, 2.5211313676959067`*^-11, 
      1.895015325715795`, 0.32184010437507343`, 6.9998144544281985`*^-6, 
      0.22222222206556375`, 3.017928005782829`*^-11, 9.06274016427194`*^-12, 
      399.9999999846908`, 17.466666662236893`, 4.754526764540033`*^-12, 
      3.1015633521253827`*^-12, 2.2681864057049053`*^-12, 
      1.7776886879344652`*^-12, 24.`, 5.961307980494534`, 
      1.948991781684357`*^-8, 2.906811990337581`, 9.66069194877877`*^-9, 
      3.25415910686366`*^-10, 2.2288704948914414`*^-10, 
      1.3247331838338381`*^-10, 2.9414126047722187`*^-6, 
      3.868904428431171`*^-7, 9.044459252874978`*^-11, 
      6.761193096688734`*^-11, 5.3647901090151947`*^-11, 
      4.434706087498244`*^-11, 3.77525894422544`*^-11, 164.`, 
      15.41600001663438`, 14.920958090982937`, 55.678098493083134`, 
      4.245030017113038`*^-9, 6.6662611006151085`*^-9, 
      7.941696650095681`*^-9, 5.360107974742279`*^-9, 
      3.3703945539517815`*^-10, 2.623208452596341`*^-14, 1.605681365057792`, 
      3.1135683977474`, 4.8041598073386945`*^-15, 38.46279282791698`, 
      2.469679923100837`, 0.04217987151970697`, 0.01514338411334567`, 
      0.006403900876438618`, 0.002711111787359258`, 0.0008771929498192385`, 
      0.00032169308813977967`, 5.751666620831504`*^-15, 11.572992216038461`, 
      1.1726177314179824`*^-7, 1.2696516057121552`, 5.711968823060039`*^-15, 
      7.73839932339983`*^-9, 5.830682462432341`*^-6, 0.8378639957568093`, 
      1.4149921365660555`*^-6, 6.333390416258943`*^-10, 3.37964899909728`, 
      4.309520076796287`*^7, 4.464413883746669`*^7, 4.309521552411435`*^7, 
      4.9483865418163076`*^7, 8.642501989859324`*^-11, 
      7.561254470016275`*^-15, 1.5622077865777833`*^-8, 6.195211521515979`, 
      9.371094188326565`*^-15, 5.314480570768664`*^-16, 48.02450723238213`, 
      23.3100965814952`, 0.4887881863042498`, 1.3683521788013648`, 
      2.134736684752661`*^-9, 0.4687519018093128`, 2.0141450720614853`*^-9, 
      2.70142433059749`*^-9, 2.4514874512998918`*^-11, 0.07820509682841871`, 
      2.968283131283341`*^-10, 0.00093263882084456`, 4.309529533136195`*^7, 
      4.30952718130403`*^7, 4.309530113157519`*^7, 4.309530726527053`*^7, 
      4.309527899529659`*^7, 4.3095275179300055`*^7, 4.309529928204557`*^7, 
      4.309528959666404`*^7, 4.3095275181640685`*^7, 4.309527191331699`*^7, 
      4.309533257077724`*^7, 4.309530570694934`*^7, 4.3095351176555306`*^7, 
      4.309529940358049`*^7, 4.3095400864846274`*^7, 4.309531087045211`*^7, 
      4.3095317457364865`*^7, 4.309532790217491`*^7, 432.45788251398534`, 
      15.573334214483086`, 2025.5638525243417`, 149.7169189265117`, 
      270.0934365957808`, 49665.163314543024`, 49665.16332454553`, 
      0.000011735679130485703`, 0.000010171090721893114`, 
      0.00001499915952002948`, 0.00001245691406820393`, 
      0.000015326768088854098`, 140.41899680883662`, 5826.4593647857155`, 
      0.000012093154292202625`, 467.42877746937216`, 0.00004238396583652578`, 
      0.00001772887579367592`, 0.000013567231329259595`, 
      5.7525068860451774`*^-15, 0.000021410964445514255`, 
      0.00001200841910467597`, 1927.6473088158552`, 3432.254634353634`, 
      125.03659012373059`, 5521.097643709008`, 643.899887451743`, 
      4789.519516055369`, 3792.1596553821228`, 1031.6098470251566`, 
      511.009465309215`, 1802.9191380292518`, 952.149889552062`, 
      582.2495012610935`, 305.50974365027884`, 5644.398420711967`, 
      3575.69944968194`, 2.23203290438069`*^-16, 913.7897824700275`, 
      14800.652328011083`, 1387.64743561812`, 5.470325392028413`*^-6, 
      0.00002208486068262577`, 1105.481378164559`, 350.6887120374125`, 
      1451.9374399181545`, 793.3417285675378`, 312.8875611339652`, 
      0.00002778994511237992`, 0.000058206683461669954`, 234.3619042427819`, 
      0.000033412248333225536`, 0.0002914800352458377`, 
      0.0001076657785055923`, 0.0000446809124982675`, 
      2.2320421482416546`*^-16, 0.00007144635036416152`, 
      0.00006997851796746624`, 0.0000232164516623932`, 
      4.491173037623802`*^-6, 8.256798198844257`*^-6, 
      8.642501989859324`*^-11, 7.561254470016275`*^-15, 
      1.5622077865777833`*^-8, 6.195211521515979`, 9.371094188326565`*^-15, 
      5.314480570768664`*^-16, 48.02450723238213`, 23.3100965814952`, 
      0.4887881863042498`, 1.3683521788013648`, 2.134736684752661`*^-9, 
      0.4687519018093128`, 2.0141450720614853`*^-9, 2.70142433059749`*^-9, 
      2.4514874512998918`*^-11, 0.07820509682841871`, 
      2.968283131283341`*^-10, 0.00093263882084456`, 25.24773722573211`, 
      0.04000262511073459`, 24.171545901368727`, 36.62033704907474`, 
      5.6007911629618965`, 1.784974363392077`*^-8, 1.187337400625947`, 
      24.4051688741895`, 1.868639057587303`*^-8, 0.27385143656661276`, 
      23.65999768881412`, 18.16831802529211`, 59.00715953728811`, 
      72.475761416094`, 151.44038307068837`, 2.0773332797204412`*^-7, 
      4.811570337389738`*^-9, 1.0699257072366562`*^-8, 
      1.3991794874703503`*^-15, 3.087928048293872`*^-15, 
      5.051775134798182`*^-16, 2.219379509902912`*^-16, 
      7.81504346528122`*^-16, 1.1759611885098142`*^-15, 111.87138878322767`, 
      29.999999731693684`, 0.9775765001862944`, 3.0783644896973095`, 
      2.007417473079593`*^-6, 2.7692662612893977`*^-11, 
      4.070946085409462`*^-11, 6.914572046985542`*^-11, 
      7.424105660010251`*^-11, 2.0514255193719135`, 0.06999991972109273`, 
      0.0018746107252950788`, 1.7146417041178814`, 10.322030899918143`, 
      1.5291681403667001`, 5.70389362496667`, 15.380390729944995`, 
      3.977048672229863`, 3.0042020536592355`, 9.73548438407058`, 
      10.824564909503708`, 3.1874599594421076`, 2.995044951862913`, 
      23.666648394962085`, 10.908831394986453`, 28.279691609683187`, 
      25.726731134922677`, 55.442024879790324`, 17.39132098902929`, 
      49.71278452799566`, 34.709856141860996`, 0.9067280341598115`, 
      0.29455612410249654`, 21.006665606009978`, 1.7399554981127463`, 
      3.797790322239991`, 45.46224258181814`, 7.666248205636803`*^-16, 
      0.5186279091735848`, 745.0347178825662`, 86.13028808025973`, 
      4.692367224767791`, 17.085004876346158`, 9.999939460859602`*^-6, 
      3.75470615692454`*^-12, 2.2565061707111952`*^-12, 
      2.1126407865256986`*^-12, 2.4533849279524243`*^-12, 3.943373958534382`, 
      0.4730400002387974`, 0.0067499999862117655`, 0.3266666666128912`, 
      1.0362024010523426`*^-11, 3.1069268022506027`*^-12, 587.9999999950089`, 
      25.67599999848677`, 1.6293144548884777`*^-12, 1.0626769995089342`*^-12, 
      7.77061605915291`*^-13, 6.089814958796083`*^-13, 0.`, 
      7.431078789725594`*^-11, 5.968340092980438`, 7.499068209566508`*^-11, 
      5.184828306342562`, 0.3092566619361931`, 2.160571355055388`*^-11, 
      3.5442658151988446`*^-12, 440.99999999738185`, 85.04558204419598`, 
      1.5910208650714673`*^-12, 9.720322829085466`*^-13, 
      6.867771324181618`*^-13, 5.271388005283097`*^-13, 
      4.2651488982127434`*^-13, 0.`, 3.656960027897532`, 4.94737868952756`, 
      51.96129634423872`, 3.033994061096109`*^-11, 2.231117074238337`*^-11, 
      1.99862232861196`*^-11, 1.888542418336492`*^-11, 0.19663224402006535`, 
      1.3283649919596657`*^-7, 11.681816587384187`, 1.9524756661887297`*^-7, 
      6.856306142491331`*^-10, 259.7999052207103`, 4.132548888842683`, 
      0.9872438130286547`, 0.012756169520024247`, 6.8035764149781`*^-10, 
      1.268356372203141`*^-10, 2.173639862240313`*^-11, 
      7.719279874506825`*^-12, 7.705315997834719`*^-16, 0.9391177752978231`, 
      6.999999999806834`, 4.9999999998677405`, 7.703618034045634`*^-16, 
      3.175332359905863`*^-11, 2.34740613528994`*^-11, 
      2.0817221130954172`*^-11, 1.985935868568364`*^-11, 
      0.008192999959111978`, 4.641382000001016`, 4.3095203785201065`*^7, 
      4.464414708667927`*^7, 4.309521225413086`*^7, 4.948389327240182`*^7, 
      2.0296982492409348`*^-11, 2.07528035294703`*^-11, 
      5.25115647675956`*^-8, 3.183058626277635`*^-8, 
      2.3526840259063943`*^-11, 5.762995854017057`*^-10, 124.6127301641671`, 
      63.373038283817074`, 8.838782747812971`*^-10, 19.20848985326097`, 
      1.8698291197474108`*^-8, 0.5784536197123636`, 0.2009939997082265`, 
      0.25937399964937224`, 1.8308447190774155`*^-10, 3.1412358000276956`, 
      2.588800767694885`*^-10, 1.916244795470482`*^-10, 
      4.3095307726214714`*^7, 4.30952571218941`*^7, 4.309531002744824`*^7, 
      4.309531863104243`*^7, 4.309528113424582`*^7, 4.3095271250942305`*^7, 
      4.309530353648781`*^7, 4.309528835451092`*^7, 4.309527119047694`*^7, 
      4.309526658460612`*^7, 4.309532705366921`*^7, 4.3095301680156134`*^7, 
      4.30953380976698`*^7, 4.309536353304792`*^7, 4.309538788392631`*^7, 
      4.309530342220122`*^7, 4.309530125465441`*^7, 4.309531591140083`*^7, 
      451.2956020383222`, 16.251703674465737`, 2025.5638525319523`, 
      156.23853742587892`, 119.21955152133059`, 55711.46330429185`, 
      55711.46330492894`, 3.28690152664386`*^-6, 2303.027342213628`, 
      2333.473632432409`, 4.853655340307278`*^-6, 2977.1904284440393`, 
      589.3486325031212`, 7402.742187601762`, 2.0580147236920596`*^-6, 
      3.9740088989832344`*^-6, 3.2608709626516562`*^-6, 
      3.704806056864014`*^-6, 1860.7628721759963`, 5.752506874171571`*^-15, 
      9.881318643037895`*^-7, 1.2480992103548554`*^-6, 
      2.9099840011761904`*^-6, 4.296921512150645`*^-6, 130.48312401582763`, 
      4134.216259976018`, 1.141077787924317`*^-6, 5.948955533476268`*^-7, 
      4622.554680470913`, 1.4035655506047334`*^-6, 5.350112742641362`*^-7, 
      4.1003293579919`*^-7, 1160.6491677045472`, 709.7494794194864`, 
      372.4096633085466`, 6880.394526547227`, 2.26924048748339`*^-6, 
      2.232047448559249`*^-16, 1113.8894029828891`, 18041.664058773684`, 
      7550.062496275911`, 10998.613274670717`, 0.000010304441147953821`, 
      1.0563358840405903`*^-6, 7.513542284783438`*^-7, 
      4.231474240309865`*^-7, 1.2665843404942296`*^-6, 7.08542631256708`*^-7, 
      3.6384500449784446`*^-7, 3.608467113747466`*^-7, 
      2.574943888522768`*^-6, 1.4102701926583828`*^-6, 
      1.8301361548222946`*^-6, 1.835467173648479`*^-6, 4.99201143713034`*^-7, 
      5.752506861459728`*^-15, 1.6745988904386756`*^-6, 
      1.3258113702932716`*^-6, 2.2948036823431035`*^-6, 
      2.56269146842384`*^-6, 8.876429952395316`*^-7, 
      2.0296982492409348`*^-11, 2.07528035294703`*^-11, 
      5.25115647675956`*^-8, 3.183058626277635`*^-8, 
      2.3526840259063943`*^-11, 5.762995854017057`*^-10, 124.6127301641671`, 
      63.373038283817074`, 8.838782747812971`*^-10, 19.20848985326097`, 
      1.8698291197474108`*^-8, 0.5784536197123636`, 0.2009939997082265`, 
      0.25937399964937224`, 1.8308447190774155`*^-10, 3.1412358000276956`, 
      2.588800767694885`*^-10, 1.916244795470482`*^-10, 50.29299228912073`, 
      10.29505012499278`, 47.34913989198514`, 67.92726495028289`, 
      24.675826522142504`, 14.698671216676743`, 51.77504925953338`, 
      54.09128838028819`, 13.649559824093448`, 12.87830265099077`, 
      112.70191408026844`, 60.55259762869254`, 140.95665218168205`, 
      136.4645099093468`, 285.91690568106577`, 75.3376270475071`, 
      218.42181021450068`, 161.95392670968883`, 1.1319657182362515`, 
      0.45316310928425035`, 34.620242693089544`, 11.922496098631042`, 
      4.71099807977162`*^-11, 0.5186279103261818`, 1.8724132061701315`*^-7, 
      29.999999622026024`, 1.2731355465151777`*^-10, 5.888646910098647`*^-9, 
      1.1025725200844195`*^-9, 1.691864959448935`*^-11, 
      2.2834987058636433`*^-11, 3.7544166334316465`*^-11, 
      7.2229851732659166`*^-12, 4.6004532967180406`*^-10, 
      1.0076087455169938`*^-12, 1.672711882663499`*^-11, 37.534778786677485`, 
      2.6182025749806774`*^-9, 2.0117557295857044`*^-9, 
      4.0084356145052855`*^-9, 7.014374647603744`*^-9, 
      3.940488566298691`*^-9, 3.006584147008704`*^-9, 
      2.8807605505218253`*^-9, 7.804366260661696`*^-9, 
      3.936057093478091`*^-9, 7.632465957707084`*^-9, 7.158252736453939`*^-9, 
      2.119218327457687`*^-9, 2.7679471488290705`*^-9, 
      2.201135929913305`*^-8, 1.9760365356972943`*^-9, 
      6.858496407063329`*^-9, 2.373742574617102`*^-9, 5.21613504774984`*^-9, 
      3.8498399313468123`, 1.472780620346126`, 44.570217913035115`, 
      8.577499632007346`, 21.08667830255772`, 181.78521301286028`, 
      7.708903606555214`*^-16, 2.5566922392585663`, 854.0281233415158`, 
      329.1275507135793`, 5.2817898711199234`*^-11, 44.972483917095154`, 
      9.999650904059391`*^-6, 5.901020078393607`*^-12, 
      1.232707939689219`*^-11, 3.195208361613791`*^-12, 
      3.781214027890981`*^-12, 9.632256583465912`, 0.46427989813850623`, 
      0.006750000032059824`, 0.4799999998088998`, 3.682784319382092`*^-11, 
      1.1047065470348062`*^-11, 863.9999999811592`, 37.72799999460493`, 
      5.794118222513083`*^-12, 3.7793699801069754`*^-12, 
      2.763728328998014`*^-12, 2.1659996624606747`*^-12, 0.`, 
      3.632892358249649`*^-10, 5.417404759535737`, 3.735564598097423`*^-10, 
      6.647691479516307`, 0.4544179522039415`, 4.33078636804445`*^-11, 
      7.102824129723719`*^-12, 647.9999999926832`, 124.96493687886249`, 
      3.1890722324333042`*^-12, 1.9483969533007713`*^-12, 
      1.3766073620984283`*^-12, 1.0566149869007144`*^-12, 
      8.549175665861724`*^-13, 0.`, 5.3734922858256855`, 6.156449929380294`, 
      106.9237468298101`, 5.928654595022355`*^-11, 1.5307384405160458`*^-10, 
      1.200505500953071`*^-10, 3.254756954351845`*^-11, 2.97424294283745`, 
      1.0838747378684483`*^-6, 3.036141917711587`*^-8, 
      4.8302660980356214`*^-8, 0.08463826401060297`, 903.5142005685104`, 
      1.0709680128689317`*^-7, 0.13388613295635227`, 0.36706450015914766`, 
      0.3706255662240785`, 0.03144688826130802`, 0.004133838209750073`, 
      0.0013914971995894043`, 7.703288039195188`*^-16, 13.984886221654842`, 
      6.999999999447203`, 4.999999999938868`, 7.696866070669875`*^-16, 
      6.45526701530568`*^-11, 2.1955213099390084`*^-10, 
      1.5472377755790345`*^-10, 3.530163849946494`*^-11, 
      0.009958999953747097`, 6.150956000131739`, 4.309521125802081`*^7, 
      4.464416141701996`*^7, 4.3095228949577264`*^7, 4.948395872307384`*^7, 
      2.918344651376149`*^-10, 2.6156493619897993`*^-10, 
      2.964655571990967`*^-7, 1.947906735484811`*^-8, 
      1.2716053046378576`*^-10, 0.01822365995275456`, 
      4.4658717880572226`*^-7, 6.696347560814674`*^-7, 2.346183613423653`, 
      1.7165148863424957`*^-8, 1.7879079661330866`*^-8, 0.32896689581849625`, 
      0.1207891998254848`, 0.15587319983111197`, 1.6749684272583275`*^-10, 
      1.270987042774877`*^-9, 2.3589503817261092`*^-11, 
      1.810079501214832`*^-10, 4.309532546269771`*^7, 4.309526383110069`*^7, 
      4.30953214929097`*^7, 4.309533855056874`*^7, 4.309528620180037`*^7, 
      4.309527312978725`*^7, 4.309531914609477`*^7, 4.309530350746277`*^7, 
      4.309527158704489`*^7, 4.30952685987244`*^7, 4.309536272146161`*^7, 
      4.3095310350569285`*^7, 4.309538410516973`*^7, 4.309541066913671`*^7, 
      4.309550578424566`*^7, 4.309533099985758`*^7, 4.3095334346840546`*^7, 
      4.309536510423223`*^7, 732.2646393732381`, 21.437514405456735`, 
      3127.999313725706`, 253.51001815076418`, 211.10307635133427`, 
      81313.8124710329`, 81313.81247175747`, 1.2718708997313275`*^-6, 
      1233.7659748364065`, 2451.8229932504923`, 1.7058381745082727`*^-6, 
      761.5444427903805`, 619.239500891166`, 7778.191405257003`, 
      1.3685561261084797`*^-6, 1.4290753533316908`*^-6, 
      1.6269279803675173`*^-6, 1.8614945866800162`*^-6, 
      1.6370076252095303`*^-6, 5.752506874474544`*^-15, 
      8.723492671142277`*^-7, 1.3550420392128122`*^-6, 
      1.5763924318718561`*^-6, 1.6636633496996337`*^-6, 
      1.3977780016953485`*^-6, 8180.898436455694`, 0.00003165347751163481`, 
      8.11461815986513`*^-6, 5619.039061169599`, 1528.5895566445809`, 
      1.3093372703844829`*^-6, 7.835232133155778`*^-7, 1410.849607564451`, 
      862.7497543689524`, 452.68969519980567`, 8363.597654036226`, 
      5298.2968733506295`, 2.2320437004598286`*^-16, 1354.0097650895004`, 
      21930.89452864349`, 9177.624998288478`, 13369.578128230389`, 
      416.149900474135`, 5.292845619086746`*^-6, 2.3262537322339043`*^-6, 
      1.3942904164517586`*^-6, 3.8058624789192924`*^-6, 
      1.6456641707953356`*^-6, 6.548304853447843`*^-7, 
      6.376587924854086`*^-7, 0.00005844020367486895`, 
      0.0000281211002939861`, 9.443149947601466`*^-6, 
      6.0155894887436285`*^-6, 1.292536413920357`*^-6, 
      5.7525068665422134`*^-15, 3.43997368080106`*^-6, 
      1.5566633355841503`*^-6, 0.000030049019636345375`, 5035.2929518409255`, 
      4.098005982287162`*^-6, 2.918344651376149`*^-10, 
      2.6156493619897993`*^-10, 2.964655571990967`*^-7, 
      1.947906735484811`*^-8, 1.2716053046378576`*^-10, 0.01822365995275456`, 
      4.4658717880572226`*^-7, 6.696347560814674`*^-7, 2.346183613423653`, 
      1.7165148863424957`*^-8, 1.7879079661330866`*^-8, 0.32896689581849625`, 
      0.1207891998254848`, 0.15587319983111197`, 1.6749684272583275`*^-10, 
      1.270987042774877`*^-9, 2.3589503817261092`*^-11, 
      1.810079501214832`*^-10, 7.221778613931094`*^-9, 
      6.0286202337115096`*^-9, 1.1326990488234102`*^-8, 
      1.972504808776364`*^-8, 1.1636823182280094`*^-8, 
      1.4124530172067164`*^-8, 1.3257634712140298`*^-8, 
      2.243589980248016`*^-8, 2.1369050152209154`*^-8, 
      2.9183220848962046`*^-8, 2.0262593682942105`*^-8, 
      5.828888416763645`*^-9, 7.474491657436572`*^-9, 6.365965256365774`*^-8, 
      5.148176294904226`*^-9, 8.30237620662493`*^-8, 90.21660481155881`, 
      11.588047598100324`, 6.967683386997262`*^-11, 7.101825124144454`*^-11, 
      1.6758875202422488`*^-7, 1.474613207524913`*^-8, 
      2.9021541569358288`*^-11, 7.763628924321676`*^-9, 
      3.270980078288038`*^-7, 29.99999922965014`, 2.0709875542868612`*^-10, 
      5.24639228578807`, 1.1420465365229435`*^-9, 3.351044733433764`*^-11, 
      4.546804805004914`*^-11, 7.509414583263106`*^-11, 
      1.4494429181011168`*^-11, 0.6629053457865464`, 
      1.4512955302843866`*^-11, 4.963906851795584`*^-11, 
      8.735979912132916`*^-9, 8.600644290872692`, 1.6005370165006176`, 
      8.537409471813275`, 12.093120686016919`, 3.926903918192217`, 
      2.8312400597004017`, 10.150113631128823`, 9.304832116658881`, 
      2.6426108004506315`, 2.5507114124896804`, 21.56709556261847`, 
      9.268979167603424`, 25.561061498473144`, 24.082626256545964`, 
      48.958320549595825`, 15.67497521609284`, 3.3233916355123385`*^-8, 
      8.524889314302051`*^-8, 4.358714508258079`, 2.0983215067909606`, 
      60.33983869279299`, 10.248595086241354`, 3.645962025812557`, 
      179.61421397784937`, 7.703910677442933`*^-16, 3.05479498419751`, 
      763.0966367924174`, 950.7556380058228`, 8.225996754580326`*^-11, 
      57.81680313524509`, 9.99994066990205`*^-6, 7.089502835336518`*^-12, 
      9.552091979270777`*^-12, 3.79772869155035`*^-12, 
      4.556598464280395`*^-12, 12.2838779721516`, 0.4555199997929839`, 
      0.044519999401708886`, 0.7049999997690182`, 4.468858962905985`*^-11, 
      1.3396249372728178`*^-11, 1268.9999999791698`, 55.41299999354359`, 
      7.024846731728065`*^-12, 4.581704170088858`*^-12, 
      3.350256769400637`*^-12, 2.625578347646526`*^-12, 0.`, 
      2.964608685628663`*^-10, 5.123449069346689`, 2.984608721223227`*^-10, 
      8.027210749398789`, 0.6676016829067574`, 4.8813365151789666`*^-11, 
      7.999704121785345`*^-12, 951.9999999944375`, 183.59046282581738`, 
      3.5909386197074776`*^-12, 2.193735842902665`*^-12, 
      1.5498594053659466`*^-12, 1.1895504259904124`*^-12, 
      9.624529522669126`*^-13, 0.`, 7.894389901510559`, 7.865592048599953`, 
      131.18298606182077`, 6.845244979303265`*^-11, 1.0856462880810143`*^-10, 
      9.017318533071894`*^-11, 3.786036894196311`*^-11, 3.3789186772113373`, 
      6.34779621677467`*^-8, 1.0715456630644898`*^-8, 1.629818231263606`*^-8, 
      8.102800515464488`*^-10, 1541.7995940926123`, 3.253688864796185`*^-8, 
      1.4010043743589216`*^-10, 2.5979426385241166`*^-10, 
      0.8351906995093251`, 0.1648092999119866`, 5.4944778636489967`*^-11, 
      1.4067689633503135`*^-11, 7.701092817073714`*^-16, 19.947999595963655`, 
      6.999999999478602`, 4.999999999914219`, 7.696313815429737`*^-16, 
      7.523919723707199`*^-11, 1.3719541632106022`*^-10, 
      1.0745686974412354`*^-10, 4.151802220997508`*^-11, 
      0.012068999951975818`, 7.863315999927377`, 4.309523297409031`*^7, 
      4.464416847921371`*^7, 4.309525614359873`*^7, 4.948398609858421`*^7, 
      1.7118247660675552`*^-10, 1.7040480648898792`*^-10, 
      4.0800475426999285`*^-7, 8.763508744493765`*^-8, 
      2.8206181714873267`*^-10, 3.3746136463117494`*^-9, 
      7.838572181305471`*^-7, 1.2387187494243074`*^-6, 1.876946891652463`, 
      1.5110210886908137`*^-8, 1.8677579087732084`*^-8, 0.1285715168541101`, 
      0.05638436013606522`, 0.07276156031698901`, 2.2822659872076177`*^-10, 
      1.1357635241391222`*^-9, 2.602013602022976`*^-10, 
      1.4032199386159194`*^-10, 4.3095336581585445`*^7, 
      4.3095268113432825`*^7, 4.309532453982131`*^7, 4.309535021600093`*^7, 
      4.309528535701859`*^7, 4.309527266559852`*^7, 4.309532634954513`*^7, 
      4.309531069094862`*^7, 4.309526977734473`*^7, 4.3095270533500396`*^7, 
      4.3095388099761754`*^7, 4.309530757956542`*^7, 4.3095422628955424`*^7, 
      4.3095442510379806`*^7, 4.309563606697721`*^7, 4.309535159875326`*^7, 
      4.3095357161733426`*^7, 4.30954145484896`*^7, 915.7292776329429`, 
      24.96388679194245`, 3736.145563575813`, 317.02547591651677`, 
      310.0698065469877`, 96137.03500841049`, 96137.03500916115`, 
      1.492648887286126`*^-6, 0.000015507773968595267`, 2567.0305117748026`, 
      1.8463483189366098`*^-6, 0.000013770502470931913`, 648.3366685571634`, 
      8143.679687068489`, 1.4280471710344673`*^-6, 1.581931176805257`*^-6, 
      1.6168631827952125`*^-6, 1.8208820542840162`*^-6, 
      2.178410494412989`*^-6, 2.2320324012124355`*^-16, 
      9.138650610562515`*^-7, 1.4700833748011879`*^-6, 
      1.6266743645360564`*^-6, 1.8957104048584014`*^-6, 
      1.5822478121514547`*^-6, 9913.79296707744`, 0.000044449491742060924`, 
      6.727055049058131`*^-6, 6809.277341974639`, 1852.3791304508532`, 
      1.6580289393587118`*^-6, 9.754097174270084`*^-7, 1709.699217485519`, 
      1045.4995101104744`, 548.5795881535967`, 10135.195308042988`, 
      6420.593747802562`, 2.2320433279512683`*^-16, 1640.8193350416714`, 
      26576.347658527273`, 11121.652338197153`, 16201.550777954764`, 
      504.2998032372897`, 3.483070403874903`*^-6, 2.441102357654334`*^-6, 
      1.3838404796439138`*^-6, 3.488986023411064`*^-6, 
      1.8400050396694427`*^-6, 7.497843606144115`*^-7, 
      7.651901517225846`*^-7, 0.000037147117318902384`, 
      0.00001110794100751605`, 0.00001075054545156696`, 
      7.160565371400174`*^-6, 1.1379560656622967`*^-6, 
      2.2320429153212424`*^-16, 3.3583338486815376`*^-6, 
      1.5295323160786104`*^-6, 0.000025431672113467984`, 2317.136917431443`, 
      3.333616876424647`*^-6, 1.7118247660675552`*^-10, 
      1.7040480648898792`*^-10, 4.0800475426999285`*^-7, 
      8.763508744493765`*^-8, 2.8206181714873267`*^-10, 
      3.3746136463117494`*^-9, 7.838572181305471`*^-7, 
      1.2387187494243074`*^-6, 1.876946891652463`, 1.5110210886908137`*^-8, 
      1.8677579087732084`*^-8, 0.1285715168541101`, 0.05638436013606522`, 
      0.07276156031698901`, 2.2822659872076177`*^-10, 
      1.1357635241391222`*^-9, 2.602013602022976`*^-10, 
      1.4032199386159194`*^-10, 6.162568012476737`*^-9, 
      5.164608744590785`*^-9, 9.610490718859097`*^-9, 
      1.6824001910879455`*^-8, 9.777476692875626`*^-9, 
      9.334173263500874`*^-9, 7.82073760626595`*^-9, 1.9010044031782963`*^-8, 
      1.3465708782701823`*^-8, 2.2006737147439788`*^-8, 
      1.7068101165970203`*^-8, 4.957865798158826`*^-9, 
      6.363566404161272`*^-9, 5.387950419850535`*^-8, 4.396044295173098`*^-9, 
      2.5984657868553067`*^-8, 1.6307435123958115`*^-8, 
      2.9203821111431274`*^-8, 0.7828836900716958`, 0.9623702573313954`, 
      6.3630820066336`*^-7, 4.235052659990019`*^-8, 2.4457412660787035`*^-10, 
      0.46894486470913066`, 9.915721885080591`*^-7, 510.0782897849899`, 
      1.0281306968977696`*^-9, 7.807185923620089`*^-8, 
      4.470210433433966`*^-9, 2.6678527172041463`*^-10, 
      3.6459340017390286`*^-10, 6.050966475855885`*^-10, 
      1.3125592716738088`*^-10, 5.888771945673743`*^-9, 
      4.3714063992929763`*^-7, 0.04399994828747748`, 6.3070813714708535`*^-9, 
      8.867264305565502`, 1.650153696193518`, 8.802069230136828`, 
      12.468007539977517`, 4.048638003945272`, 2.919008583202821`, 
      10.464767221024145`, 9.5932820383242`, 2.7245318311011104`, 
      2.6297835948184267`, 22.235675640559116`, 9.556317555453848`, 
      26.353454448324488`, 24.8291880267862`, 50.47602851660194`, 
      16.16090018220927`, 13.733562038549346`, 108.51178135796349`, 
      4.309518827880268`*^7, 4.4644105695692606`*^7, 4.309520100620655`*^7, 
      4.948383986236289`*^7, 4.309523122409915`*^7, 4.309526202449074`*^7, 
      4.3095231759265274`*^7, 4.3095216572213106`*^7, 4.309525251977586`*^7, 
      4.309525507941667`*^7, 4.309523087020607`*^7, 4.3095243723303035`*^7, 
      4.3095256958924904`*^7, 4.309525332815377`*^7, 4.30951893009845`*^7, 
      4.309524973008714`*^7, 4.309517695045873`*^7, 4.30951425803975`*^7, 
      4.3095123950524`*^7, 4.30952066627631`*^7, 4.3095192209045276`*^7, 
      4.309516410499989`*^7, 4.309520024666369`*^7, 4.464412978243672`*^7, 
      4.3095206092679955`*^7, 4.948386235495762`*^7, 4.309524636640313`*^7, 
      4.3095253022791825`*^7, 4.3095259206284076`*^7, 4.309522547506728`*^7, 
      4.309526381212371`*^7, 4.309525758470856`*^7, 4.309525950192263`*^7, 
      4.309524379781741`*^7, 4.309525742204898`*^7, 4.309525232760976`*^7, 
      4.3095211634399466`*^7, 4.3095259043013066`*^7, 4.3095181285701394`*^7, 
      4.309521609374977`*^7, 4.309511504926397`*^7, 4.309522525114058`*^7, 
      4.309521866958353`*^7, 4.309520567668521`*^7, 4.3095206513874955`*^7, 
      4.464413105610051`*^7, 4.30952172634358`*^7, 4.948385216926479`*^7, 
      4.309523242329836`*^7, 4.309525169889789`*^7, 4.309523906091598`*^7, 
      4.309520423432683`*^7, 4.309525104328965`*^7, 4.309524906563812`*^7, 
      4.309523750529287`*^7, 4.309522054201876`*^7, 4.3095248366266154`*^7, 
      4.3095245625105225`*^7, 4.30951698302512`*^7, 4.309522430089112`*^7, 
      4.3095134161810145`*^7, 4.309517278884884`*^7, 4.309503759378106`*^7, 
      4.309520011241861`*^7, 4.309519221000172`*^7, 4.309517073884522`*^7, 
      4.3095226486590005`*^7, 4.464412944709678`*^7, 4.3095240483964294`*^7, 
      4.948385814765131`*^7, 4.309522320718807`*^7, 4.309525116059551`*^7, 
      4.309521993767128`*^7, 4.309518800653632`*^7, 4.309523944957425`*^7, 
      4.309524059470244`*^7, 4.3095215078184925`*^7, 4.309520218722475`*^7, 
      4.3095239235238746`*^7, 4.309524060523352`*^7, 4.309513613309661`*^7, 
      4.3095196770792134`*^7, 4.3095106936280705`*^7, 4.309514316237195`*^7, 
      4.309503983611842`*^7, 4.309517591405059`*^7, 4.309516613606787`*^7, 
      4.3095153052136496`*^7}\)], "Output"],

Cell[BoxData[
    \(\(-2581.139261615493`\)\)], "Output"],

Cell[BoxData[
    \(0.003615951848603967`\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"Export", "[", 
      RowBox[{
        RowBox[{"rootDir", " ", "<>", 
          StyleBox["\"\<value\>\"",
            "MR"], 
          StyleBox[" ",
            "MR"], 
          StyleBox["<>",
            "MR"], "problemId", "<>", " ", 
          StyleBox["\"\<.txt\>\"",
            "MR"]}], 
        StyleBox[",",
          "MR"], " ", Cell[BoxData[
            FormBox[
              StyleBox["myValue",
                "MR"], TraditionalForm]]], ",", " ", "\"\<Lines\>\""}], 
      "]"}]], "Input"],

Cell[BoxData[
    \("D:\\DATADIR\\Programmazione\\java\\joptimizer\\src\\test\\resources\\\
lp\\value12.txt"\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"Export", "[", 
      RowBox[{
        RowBox[{"rootDir", " ", "<>", 
          StyleBox["\"\<sol\>\"",
            "MR"], 
          StyleBox[" ",
            "MR"], 
          StyleBox["<>",
            "MR"], "problemId", "<>", " ", 
          StyleBox["\"\<.txt\>\"",
            "MR"]}], 
        StyleBox[",",
          "MR"], " ", Cell[BoxData[
            FormBox[
              StyleBox["mySol",
                "MR"], TraditionalForm]]], ",", " ", "\"\<Lines\>\""}], 
      "]"}]], "Input"],

Cell[BoxData[
    \("D:\\DATADIR\\Programmazione\\java\\joptimizer\\src\\test\\resources\\\
lp\\sol12.txt"\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"Export", "[", 
      RowBox[{
        RowBox[{"rootDir", " ", "<>", 
          StyleBox["\"\<tolerance\>\"",
            "MR"], 
          StyleBox[" ",
            "MR"], 
          StyleBox["<>",
            "MR"], "problemId", "<>", " ", 
          StyleBox["\"\<.txt\>\"",
            "MR"]}], 
        StyleBox[",",
          "MR"], " ", Cell[BoxData[
            FormBox[
              StyleBox["mySol",
                "MR"], TraditionalForm]]], ",", " ", "\"\<Lines\>\""}], 
      "]"}]], "Input"],

Cell[BoxData[
    \("D:\\DATADIR\\Programmazione\\java\\joptimizer\\src\\test\\resources\\\
lp\\tolerance12.txt"\)], "Output"]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"5.0 for Microsoft Windows",
ScreenRectangle->{{0, 1920}, {0, 993}},
WindowSize->{1912, 961},
WindowMargins->{{0, Automatic}, {Automatic, 0}}
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 95, 5, 138, "Subtitle"],
Cell[1874, 60, 197, 4, 50, "Input"],

Cell[CellGroupData[{
Cell[2096, 68, 4259, 140, 193, "Input"],
Cell[6358, 210, 38, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6433, 216, 241, 5, 70, "Input"],
Cell[6677, 223, 38040, 559, 1435, "Output"],
Cell[44720, 784, 57, 1, 29, "Output"],
Cell[44780, 787, 55, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[44872, 793, 530, 17, 31, "Input"],
Cell[45405, 812, 122, 2, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[45564, 819, 526, 17, 31, "Input"],
Cell[46093, 838, 120, 2, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[46250, 845, 532, 17, 31, "Input"],
Cell[46785, 864, 126, 2, 29, "Output"]
}, Open  ]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

