(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.0'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     37241,        739]*)
(*NotebookOutlinePosition[     37885,        761]*)
(*  CellTagsIndexPosition[     37841,        757]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["\<\
Solves the LP problem defined by:
min(c) s.t.
A.x = b
lb <= x <= ub\
\>", "Subtitle"],

Cell[BoxData[{
    \(\(rootDir\  = \ \
"\<D:\\DATADIR\Programmazione\java\joptimizer\\src\\test\\resources\\lp\\\
standardization\\\>";\)\), "\[IndentingNewLine]", 
    \(\(problemId\  = \ "\<5\>";\)\)}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
    RowBox[{
      RowBox[{
        StyleBox["c",
          "MR"], 
        StyleBox["=",
          "MR"], 
        RowBox[{
          StyleBox["Import",
            "MR"], 
          StyleBox["[",
            "MR"], 
          RowBox[{
            RowBox[{"rootDir", " ", "<>", 
              StyleBox["\"\<c\>\"",
                "MR"], 
              StyleBox[" ",
                "MR"], 
              StyleBox["<>",
                "MR"], "problemId", "<>", " ", 
              StyleBox["\"\<.txt\>\"",
                "MR"]}], 
            StyleBox[",",
              "MR"], " ", Cell[BoxData[
                FormBox[
                  StyleBox["\"\<List\>\"",
                    "MR"], TraditionalForm]]]}], 
          StyleBox["]",
            "MR"]}]}], 
      StyleBox[";",
        "MR"]}], "\[IndentingNewLine]", \(n = 
        Length[c];\), "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{"A", "=", 
        RowBox[{"ReadList", "[", 
          RowBox[{
            RowBox[{"rootDir", " ", "<>", " ", 
              StyleBox["\"\<A\>\"",
                "MR"], 
              StyleBox["<>",
                "MR"], 
              StyleBox["problemId",
                "MR"], 
              StyleBox["<>",
                "MR"], 
              StyleBox["\"\<.txt\>\"",
                "MR"]}], ",", \(Table[Number, {n}]\)}], "]"}]}], 
      ";"}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{
        StyleBox["b",
          "MR"], 
        StyleBox["=",
          "MR"], 
        RowBox[{"ReadList", "[", 
          RowBox[{
            RowBox[{"rootDir", " ", "<>", " ", 
              StyleBox["\"\<b\>\"",
                "MR"], 
              StyleBox["<>",
                "MR"], 
              StyleBox["problemId",
                "MR"], 
              StyleBox["<>",
                "MR"], 
              StyleBox["\"\<.txt\>\"",
                "MR"]}], ",", "Number"}], "]"}]}], 
      ";"}], "\[IndentingNewLine]", \(bCoeff\  = \ 
        Table[{b[\([i]\)], 0}, \ {i, 
            Length[b]}];\), "\[IndentingNewLine]", \(GA\  = \ 
        A;\), "\[IndentingNewLine]", \(hbCoeff\  = \ 
        bCoeff;\), "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{
        StyleBox["lb",
          "MR"], 
        StyleBox["=",
          "MR"], 
        RowBox[{
          RowBox[{
            StyleBox["Import",
              "MR"], 
            StyleBox["[",
              "MR"], 
            RowBox[{
              RowBox[{"rootDir", " ", "<>", " ", 
                StyleBox["\"\<lb\>\"",
                  "MR"], 
                StyleBox["<>",
                  "MR"], 
                StyleBox["problemId",
                  "MR"], 
                StyleBox["<>",
                  "MR"], 
                StyleBox["\"\<.txt\>\"",
                  "MR"]}], 
              StyleBox[",",
                "MR"], " ", Cell[BoxData[
                  FormBox[
                    StyleBox["\"\<List\>\"",
                      "MR"], TraditionalForm]]]}], 
            StyleBox["]",
              "MR"]}], "/.", 
          RowBox[{"{", 
            RowBox[{"\"\<NaN\>\"", "\[Rule]", 
              RowBox[{"-", 
                StyleBox["99999999",
                  "MR"]}]}], "}"}]}]}], 
      StyleBox[";",
        "MR"]}], "\[IndentingNewLine]", 
    RowBox[{
      RowBox[{
        StyleBox["ub",
          "MR"], 
        StyleBox["=",
          "MR"], 
        RowBox[{
          RowBox[{
            StyleBox["Import",
              "MR"], 
            StyleBox["[",
              "MR"], 
            RowBox[{
              RowBox[{"rootDir", " ", "<>", " ", 
                StyleBox["\"\<ub\>\"",
                  "MR"], 
                StyleBox["<>",
                  "MR"], 
                StyleBox["problemId",
                  "MR"], 
                StyleBox["<>",
                  "MR"], 
                StyleBox["\"\<.txt\>\"",
                  "MR"]}], 
              StyleBox[",",
                "MR"], " ", Cell[BoxData[
                  FormBox[
                    StyleBox["\"\<List\>\"",
                      "MR"], TraditionalForm]]]}], 
            StyleBox["]",
              "MR"]}], "/.", 
          RowBox[{"{", 
            RowBox[{"\"\<NaN\>\"", "\[Rule]", 
              RowBox[{"+", 
                StyleBox["99999999",
                  "MR"]}]}], "}"}]}]}], 
      ";"}], "\[IndentingNewLine]", \(variablesBounds\  = \ 
        Table[{lb[\([i]\)], \ ub[\([i]\)]}, \ {i, 
            n}];\), "\[IndentingNewLine]", "n"}], "Input"],

Cell[BoxData[
    \(1123\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{\(mySol = 
      LinearProgramming[c, GA, hbCoeff, \ 
        variablesBounds]\), "\[IndentingNewLine]", \(myValue\  = \ 
      c . mySol\), "\[IndentingNewLine]", 
    RowBox[{"myTolerance", " ", "=", " ", 
      RowBox[{
        StyleBox["Norm",
          "MR"], 
        StyleBox["[",
          "MR"], \(A . mySol\  - \ b\), "]"}]}]}], "Input"],

Cell[BoxData[
    \({1.3902113265517672`*^-9, 162.6391570996729`, 85.05078310791133`, 
      0.9316239676180733`, 0.7777777778783951`, 0.9999999990357382`, 
      0.0000694559300095266`, 0.0000289294386255487`, 
      0.000039126228840414484`, 0.00006216831589557034`, 
      0.000036528776731451455`, 0.000014836926127554954`, 
      0.000016164355226605004`, 0.00007277345056629225`, 
      0.000015564905108254515`, 0.000027149777357012975`, 
      0.00003126774130414197`, 0.00005387596007444751`, 
      0.00010743068611565196`, 0.00007580551052114428`, 
      0.00007877400524995828`, 0.00001503268903893272`, 
      3.290264648223948`*^-6, 7.273978643814627`*^-6, 
      0.000016081761113904145`, 1658.8174529205558`, 25.22148442529676`, 
      1.4646022262090322`*^-8, 0.6733333333660511`, 0.6907433380308272`, 
      2.555752266098107`*^-11, 6.230615958338537`*^-7, 
      3.926890369868216`*^-7, 2.8761380367558204`*^-7, 
      6.709301256062015`*^-7, 4.174398226910243`*^-7, 
      2.6398437155596753`*^-7, 2.3824638379137006`*^-7, 
      8.548729154477611`*^-7, 6.39802349163955`*^-7, 6.997687958679094`*^-7, 
      7.139791517195827`*^-7, 4.919389872100603`*^-7, 
      1.2024792956709372`*^-6, 1.6516431393318496`*^-6, 
      1.3101275248718225`*^-6, 7.348622647552042`*^-7, 
      6.944712442526324`*^-7, 5.740370695337734`*^-7, 6.198201904127204`*^-7, 
      2.1667237615292305`*^-6, 56.03169302776712`, 5.639931897157555`*^-9, 
      0.08763341326818047`, 0.5200000001222358`, 0.5455820477360492`, 
      2.2929842217175982`*^-10, 1.3414114161503506`*^-6, 
      6.380654945676453`*^-7, 6.182766567088881`*^-7, 
      1.1463567264985897`*^-6, 6.714752677532495`*^-7, 
      4.115479322430606`*^-7, 3.5103675805775096`*^-7, 
      1.4022211326139906`*^-6, 1.2384987442844`*^-6, 1.1158599842067945`*^-6, 
      1.0813334693741329`*^-6, 1.2862665450449647`*^-6, 
      1.8256221133880059`*^-6, 3.3712749451553288`*^-6, 
      1.540882818821178`*^-6, 1.1773029919448202`*^-6, 
      1.1537205644412452`*^-6, 1.2879654751211128`*^-6, 
      6.986823147341986`*^-7, 2715.88133617334`, 28.332011462519752`, 
      1102.4355044834597`, 1.0581294338300031`*^-10, 0.2950000001482651`, 
      0.33239831702574396`, 1.3644513730051855`*^-10, 
      1.1697027335732946`*^-6, 6.808506763972529`*^-7, 
      6.319612668341789`*^-7, 1.1357157846669936`*^-6, 
      7.310406866594722`*^-7, 4.67628048756461`*^-7, 4.0475047801395323`*^-7, 
      1.4294410179025401`*^-6, 1.1888475192118688`*^-6, 
      1.1824284198905825`*^-6, 1.1634523795999546`*^-6, 
      1.1023103789363568`*^-6, 1.752681458429299`*^-6, 
      3.2785016665265965`*^-6, 1.48548109923151`*^-6, 
      1.2267233993635469`*^-6, 1.132866957410267`*^-6, 
      1.2257516991408175`*^-6, 7.317694730402409`*^-7, 3210.976951333285`, 
      17.12807372129448`, 3.911598773385687`*^-8, 2.583829009705315`*^-8, 
      5.964070999240653`*^-8, 1.0314696057413492`*^-7, 
      5.655294081169928`*^-8, 6.177111206112588`*^-8, 6.090172872997627`*^-8, 
      1.1287217014674813`*^-7, 3.526657053545066`*^-8, 6.75802574453462`*^-8, 
      1.0767874039544926`*^-7, 3.1810589666394976`*^-8, 
      4.146931410026312`*^-8, 3.1685411840513776`*^-7, 
      2.881117604412332`*^-8, 5.952486851751106`*^-7, 13.733566869628829`, 
      108.51179627733035`, 608.1462109342978`, 0.1183500650176577`, 
      1.2429541674468172`*^-13, 3.2672334251448247`, 6.238198041179264`*^-13, 
      1.4423437543013977`, 12.999999970356594`, 0.`, 2.784478569167569`*^-13, 
      560.0198649637304`, 34.46760289789991`, 1.5640581574440265`*^-8, 
      49.09165826773643`, 1.998139962919893`*^-6, 0.36422808700644355`, 
      0.2554600591913418`, 0.3296600757646248`, 2.51486035757734`*^-11, 
      1.895016035137329`, 0.3218401043896118`, 6.998588680579771`*^-6, 
      0.22222222207194595`, 3.0139879602284886`*^-11, 
      8.970138820741358`*^-12, 399.9999999884725`, 17.466666662519582`, 
      4.700625295296744`*^-12, 3.0653058564636265`*^-12, 
      2.241138641832244`*^-12, 1.7562032562077833`*^-12, 24.`, 
      5.961307974858915`, 2.5126827733568005`*^-8, 2.9068119906176064`, 
      9.381079029922966`*^-9, 3.281679470015938`*^-10, 
      2.2301343376038645`*^-10, 1.3004014769598657`*^-10, 
      2.880597301456887`*^-6, 3.8103642856363334`*^-7, 
      8.792025662948195`*^-11, 6.544063284019768`*^-11, 
      5.182347272448797`*^-11, 4.2800393890293883`*^-11, 
      3.642118036858842`*^-11, 164.`, 15.41600001638929`, 
      14.920958092381232`, 55.67809847882919`, 4.3914635652482846`*^-9, 
      1.0787550115876978`*^-8, 1.857757540596227`*^-8, 
      8.629049402156092`*^-9, 3.485523222724864`*^-10, 
      5.1532081862335725`*^-12, 1.6454005758153178`, 3.046949738617949`, 
      4.938997058821384`*^-13, 38.43922195151814`, 2.4696799231587296`, 
      0.04291662082489258`, 0.015546978196277561`, 0.0062695856426040145`, 
      0.0022722027577802453`, 0.001095797956519514`, 0.0002748470049150265`, 
      0.`, 11.573006709055173`, 1.837767917496854`*^-7, 1.2696552125240357`, 
      0.`, 7.543198066619143`*^-9, 0.000021437982272457185`, 
      0.8378632240763103`, 6.330404396931903`*^-6, 5.95875719381784`*^-10, 
      3.3796489990783654`, 12.489160165190697`, 33.141772747039795`, 
      14.517908304929733`, 25.555798321962357`, 8.370559123451831`*^-11, 
      4.2373790126956116`*^-13, 1.4821918119058043`*^-8, 6.195211410276957`, 
      1.6863730069849388`*^-13, 8.84582369558537`*^-14, 48.17576191206472`, 
      23.06619842193027`, 0.48878824259761305`, 1.3683533028039727`, 
      1.3630092653509938`*^-9, 0.4687519264387513`, 2.019817417709661`*^-9, 
      3.1996129318770253`*^-9, 2.4343553909844564`*^-11, 
      0.07820453260076807`, 2.94055713684865`*^-10, 0.0009326396735237555`, 
      64.10726302862167`, 9.788546428084373`, 69.37230835855007`, 
      90.69305697083473`, 26.475519582629204`, 20.099882751703262`, 
      68.41182444989681`, 45.87336042523384`, 18.222722247242928`, 
      18.58516316115856`, 143.2697898298502`, 55.976860731840134`, 
      174.22609385848045`, 156.82318106293678`, 276.9143186211586`, 
      104.20768912136555`, 125.2483151704073`, 163.79716919362545`, 
      432.45788094629614`, 15.573334187982756`, 2025.563845183911`, 
      149.7169183836145`, 270.0934250224296`, 49665.19395980004`, 
      49665.19397588177`, 0.00002061455913139437`, 0.000020815905820280806`, 
      0.000029298693795356804`, 0.000022267502443537987`, 
      0.000030971829452951356`, 140.4181095160523`, 5826.467986214729`, 
      0.000021610566935265032`, 467.4232614149759`, 0.0001903797557338809`, 
      0.00004123704649434536`, 0.000025336768288126846`, 0.`, 
      0.00007478231300242072`, 0.000021823525557292162`, 1927.6470346016922`, 
      3432.254634343667`, 125.0365904902251`, 5521.097633748265`, 
      643.8998646193367`, 4789.519501538847`, 3792.159645192459`, 
      1031.609830058784`, 511.0086304625671`, 1802.9180297645084`, 
      952.1498793877217`, 582.2488082476174`, 305.50970272422285`, 
      5644.39839848921`, 3575.6994384855534`, 0.`, 913.7897708769004`, 
      14800.65231818647`, 1387.6500833147218`, 5.345474195423767`*^-6, 
      0.000026317822265304184`, 1105.4812272446682`, 350.687873629028`, 
      1451.9372903254014`, 793.3415725380031`, 312.8870424572746`, 
      0.00006154418476029317`, 0.00009860298123068082`, 234.3617916461816`, 
      0.0000740401223585695`, 0.0008823329764719169`, 0.0003243214258660775`, 
      0.00005387596007444751`, 0.`, 0.00007580551052114428`, 
      0.00007877400524995828`, 0.000038568837058592085`, 
      4.504781573574259`*^-6, 8.15254175664263`*^-6, 8.370559123451831`*^-11, 
      4.2373790126956116`*^-13, 1.4821918119058043`*^-8, 6.195211410276957`, 
      1.6863730069849388`*^-13, 8.84582369558537`*^-14, 48.17576191206472`, 
      23.06619842193027`, 0.48878824259761305`, 1.3683533028039727`, 
      1.3630092653509938`*^-9, 0.4687519264387513`, 2.019817417709661`*^-9, 
      3.1996129318770253`*^-9, 2.4343553909844564`*^-11, 
      0.07820453260076807`, 2.94055713684865`*^-10, 0.0009326396735237555`, 
      25.247738033726673`, 0.039932341603671054`, 24.171552120606577`, 
      36.62033851209747`, 5.600885846057845`, 3.699157485081632`*^-8, 
      1.1873509052858586`, 24.40517155478357`, 3.4645154649899786`*^-8, 
      0.27385203811789627`, 23.660004109149394`, 18.168331004141667`, 
      59.00716189020423`, 72.4757618197637`, 151.4403913585701`, 
      1.2495331911596916`*^-6, 4.88949149740055`*^-9, 
      1.1064368221686163`*^-8, 0.`, 0.`, 0.`, 0.`, 0.`, 0.`, 
      111.87138878786027`, 29.999999741760238`, 0.9775765008355929`, 
      3.078364873334157`, 2.000865677874373`*^-6, 2.7769638869860608`*^-11, 
      4.0679306323487754`*^-11, 7.06032877801439`*^-11, 
      7.353213517491019`*^-11, 2.0514251003384905`, 0.0699999197414055`, 
      0.0018746107958333923`, 1.7146417069215723`, 10.322032154109213`, 
      1.5290938529877935`, 5.703897990569994`, 15.38039185192574`, 
      3.9771418912673266`, 3.0042006569688153`, 9.735481734468197`, 
      10.82456695788901`, 3.1874671065547653`, 2.995045280454415`, 
      23.666651567062644`, 10.90884290412881`, 28.279691318349442`, 
      25.726729358047027`, 55.44202894306179`, 17.39132180185619`, 
      49.712780933794235`, 34.70984925492639`, 0.9067280432786382`, 
      0.2945561645140681`, 20.975130009494272`, 1.7399557374763144`, 
      3.829325859182398`, 45.46224325876095`, 0.`, 0.5186279802915361`, 
      743.6043465796578`, 88.4367618059855`, 4.692367205485938`, 
      17.085005071756036`, 9.999777188336179`*^-6, 4.082264582601622`*^-12, 
      2.271768547281326`*^-12, 2.2240825631416246`*^-12, 
      2.5385334762633496`*^-12, 3.9433739592462764`, 0.47303999998438095`, 
      0.006749999986960136`, 0.3266666666168907`, 1.1145435223386887`*^-11, 
      3.038219321740723`*^-12, 587.9999999986806`, 25.675999998717174`, 
      1.6267595496023947`*^-12, 1.0663429438958721`*^-12, 
      7.807966220245018`*^-13, 6.121618582387552`*^-13, 0.`, 
      7.376741439760366`*^-11, 5.9683400930009745`, 7.437939795164905`*^-11, 
      5.184828306361149`, 0.3092566619404667`, 2.241136666686252`*^-11, 
      3.4623695495399968`*^-12, 441.0000000002101`, 85.04558204507478`, 
      1.5751670073480565`*^-12, 9.646316571352008`*^-13, 
      6.82066970455702`*^-13, 5.237631610622785`*^-13, 
      4.239191544559048`*^-13, 0.`, 3.6569600279360635`, 4.947378689553262`, 
      51.96129685513779`, 3.012070597904232`*^-11, 2.248333574678215`*^-11, 
      2.01387320625359`*^-11, 1.886193513645426`*^-11, 0.19663228388690873`, 
      1.2649027045369866`*^-7, 11.681816873394261`, 1.8837797376911148`*^-7, 
      6.481205009533582`*^-10, 259.7999095436858`, 4.132546713186432`, 
      0.9872438094808368`, 0.012756175042100063`, 6.796604525396879`*^-10, 
      1.237131216780277`*^-10, 2.1185281767610183`*^-11, 
      7.53979928718889`*^-12, 0.`, 0.939117893048444`, 6.999999999810644`, 
      4.9999999998709574`, 0.`, 3.19216977619105`*^-11, 
      2.322180542189843`*^-11, 2.07730430157361`*^-11, 
      1.9720017065528952`*^-11, 0.008192999961268077`, 4.641381999993498`, 
      3.5385373681783676`, 17.304242476820946`, 6.161450907588005`, 
      30.917444109916687`, 1.992129424054775`*^-11, 2.047780485564461`*^-11, 
      5.0871376051775465`*^-8, 3.397233670774011`*^-8, 
      2.3077180944985336`*^-11, 5.602533793301704`*^-10, 125.29766488323297`, 
      62.26858107482199`, 8.887840835242244`*^-10, 19.208490489545238`, 
      2.327705803887689`*^-9, 0.5784536147867212`, 0.2009939997073815`, 
      0.2593739995535604`, 1.814828344698984`*^-10, 3.141234864909668`, 
      8.017523771989054`*^-10, 1.9707211639376835`*^-10, 61.359812185168266`, 
      4.099102571606636`, 50.821164801716805`, 93.15597519278526`, 
      17.322122499346733`, 13.666234329342842`, 44.03456634283066`, 
      44.55669331550598`, 13.768428176641464`, 14.256996348500252`, 
      115.4192706644535`, 42.63714399933815`, 156.8119690567255`, 
      147.43929836153984`, 272.8346620351076`, 78.17106181383133`, 
      82.58507257699966`, 110.23471739888191`, 451.29560040049637`, 
      16.251703646761413`, 2025.5638451879904`, 156.23853685842678`, 
      119.21955615987122`, 55711.46349926051`, 55711.46349988042`, 
      3.167818125210494`*^-6, 2303.027342268342`, 2333.4736324478763`, 
      4.681938584734528`*^-6, 2977.1904284915217`, 589.3486325196354`, 
      7402.74218760285`, 1.986759017237142`*^-6, 3.82371163141957`*^-6, 
      3.056199251306369`*^-6, 3.58320585281061`*^-6, 1860.7628787085735`, 
      0.`, 9.206046431581911`*^-7, 1.2093169583136164`*^-6, 
      2.8072180381575786`*^-6, 4.151414579215963`*^-6, 130.48312468475478`, 
      4134.216453633292`, 1.101448131223314`*^-6, 5.886339636542305`*^-7, 
      4622.554680735197`, 1.3582478593841185`*^-6, 5.17565250326731`*^-7, 
      3.9945597654930306`*^-7, 1160.6491677918018`, 709.7494807953567`, 
      372.4096635808201`, 6880.3945266936125`, 2.2064190748773844`*^-6, 0.`, 
      1113.8894030177794`, 18041.664058811406`, 7550.06249639802`, 
      10998.613274841595`, 9.653475157932673`*^-6, 1.0227246511316206`*^-6, 
      7.234434558063275`*^-7, 4.116412660898245`*^-7, 
      1.2228875688493659`*^-6, 6.816955992514113`*^-7, 
      3.4887477332901235`*^-7, 3.516510465516588`*^-7, 
      2.4302889472237676`*^-6, 1.3350426787544763`*^-6, 
      1.7093494055969478`*^-6, 1.7756131724238736`*^-6, 
      4.919389872100603`*^-7, 0.`, 1.6516431393318496`*^-6, 
      1.3101275248718225`*^-6, 2.2216167538989367`*^-6, 
      2.485044523543915`*^-6, 8.300924646587114`*^-7, 
      1.992129424054775`*^-11, 2.047780485564461`*^-11, 
      5.0871376051775465`*^-8, 3.397233670774011`*^-8, 
      2.3077180944985336`*^-11, 5.602533793301704`*^-10, 125.29766488323297`, 
      62.26858107482199`, 8.887840835242244`*^-10, 19.208490489545238`, 
      2.327705803887689`*^-9, 0.5784536147867212`, 0.2009939997073815`, 
      0.2593739995535604`, 1.814828344698984`*^-10, 3.141234864909668`, 
      8.017523771989054`*^-10, 1.9707211639376835`*^-10, 50.29299783345659`, 
      10.294694865003322`, 47.349160244798874`, 67.9272701704888`, 
      24.676273298768034`, 14.698663843467324`, 51.775035100689315`, 
      54.09129846136238`, 13.649593744944736`, 12.878304407220215`, 
      112.7019284355619`, 60.55265276218883`, 140.95664943922503`, 
      136.46450130144655`, 285.91692639847014`, 75.33763003678527`, 
      218.4217909008609`, 161.95389215179594`, 1.1319657322630707`, 
      0.45316317145463736`, 34.62024336643202`, 11.922496238207561`, 
      4.597561507501855`*^-11, 0.5186279814117144`, 1.7272079290864537`*^-7, 
      29.99999961560385`, 1.2640222262213552`*^-10, 5.450397005121211`*^-9, 
      6.487970065797846`*^-10, 1.69366722296763`*^-11, 
      2.2874288367457966`*^-11, 3.7449365663408854`*^-11, 
      7.064868530510701`*^-12, 4.241145427435948`*^-10, 
      2.44154757344818`*^-11, 1.6413396153164298`*^-11, 37.53478061538375`, 
      2.4347162801780217`*^-9, 1.860340478145712`*^-9, 
      3.703885343551876`*^-9, 6.478372717865624`*^-9, 
      3.6097834132083185`*^-9, 2.7901228075685503`*^-9, 
      2.6768572263998917`*^-9, 7.159650957585325`*^-9, 
      3.7225087334185933`*^-9, 7.156411414739594`*^-9, 
      6.621944198655431`*^-9, 1.9747680246291456`*^-9, 
      2.587077414829287`*^-9, 2.0186577750531696`*^-8, 
      1.8551471634256266`*^-9, 6.822285571515081`*^-9, 
      2.3212257589313898`*^-9, 5.1947334498294186`*^-9, 3.8498399769341343`, 
      1.4727808223985106`, 44.57021806762346`, 8.577499953961782`, 
      21.086678566650157`, 181.78521639462633`, 0.`, 2.5566923339932615`, 
      853.6936474799707`, 329.66689295846726`, 5.091713653546417`*^-11, 
      44.972484817740146`, 9.997839575352746`*^-6, 5.645369574895266`*^-12, 
      1.2196878667396914`*^-11, 3.0713095169375492`*^-12, 
      3.6229898313621878`*^-12, 9.632255394753951`, 0.4642798975115744`, 
      0.006750000039101753`, 0.4799999998178021`, 3.607655061006212`*^-11, 
      1.0848105675566217`*^-11, 863.9999999853453`, 37.72799999492794`, 
      5.700221379827103`*^-12, 3.717590520559008`*^-12, 
      2.7176770248940406`*^-12, 2.129366824623984`*^-12, 0.`, 
      3.557894494961741`*^-10, 5.417404759547082`, 3.659354121711759`*^-10, 
      6.647691479559897`, 0.454417952206574`, 4.257871537714787`*^-11, 
      7.297050570692022`*^-12, 647.9999999980247`, 124.96493687968716`, 
      3.2599640215055606`*^-12, 1.9647505401775303`*^-12, 
      1.3779132382037598`*^-12, 1.053229623918369`*^-12, 
      8.50002105025032`*^-13, 0.`, 5.373492285784537`, 6.156449929421099`, 
      106.92374938284232`, 5.693675147217719`*^-11, 1.5268560060885173`*^-10, 
      1.1928919363117588`*^-10, 3.136666337628711`*^-11, 2.974243290227471`, 
      1.0434364006071275`*^-6, 2.9604221662656168`*^-8, 
      4.736375563894021`*^-8, 0.08463799140682243`, 903.5142124066331`, 
      9.536874922729033`*^-8, 0.1291055051573665`, 0.3820156502666307`, 
      0.3661072514655952`, 0.02934923278627189`, 0.004274895160389073`, 
      0.0015140518966199339`, 0.`, 13.984886773217093`, 6.999999999460357`, 
      4.99999999996005`, 0.`, 6.219715288606032`*^-11, 
      2.2054461441039572`*^-10, 1.5436190883285643`*^-10, 
      3.383482868449609`*^-11, 0.00995899995648957`, 6.150955999987381`, 
      4.744145825505257`, 30.360918506979942`, 11.686140477657318`, 
      106.55381675064564`, 2.9512687881169524`*^-10, 
      2.6306058335127616`*^-10, 2.9107240638675156`*^-7, 
      1.957245125926271`*^-8, 1.2446451674376596`*^-10, 
      0.018223791672426704`, 4.5897568111436`*^-7, 6.490256690849946`*^-7, 
      2.34618360378295`, 1.7865101473625676`*^-8, 4.684021910965791`*^-9, 
      0.3289668918777676`, 0.12078919982401905`, 0.15587319975312836`, 
      1.6542467288344445`*^-10, 1.3156119982710523`*^-9, 
      1.0376636164897713`*^-9, 1.7953504179274587`*^-10, 93.0394032150507`, 
      12.131982609629631`, 82.43200685083866`, 134.31624558568`, 
      35.15878900885582`, 24.064145654439926`, 81.640793800354`, 
      82.96545025706291`, 23.22079999744892`, 22.973619878292084`, 
      192.89121975004673`, 86.04971362650394`, 249.94335824251175`, 
      237.88028241693974`, 468.1904771476984`, 130.88744066655636`, 
      142.1368323713541`, 194.3653892427683`, 732.2646477575292`, 
      21.437514547152684`, 3127.9993496718926`, 253.51002105375142`, 
      211.10307782981405`, 81313.81250579427`, 81313.8125064933`, 
      1.1949034748648207`*^-6, 1233.9685295426118`, 2451.8229934288483`, 
      1.6104084345296372`*^-6, 761.3400880290549`, 619.2395009522907`, 
      7778.191405284006`, 1.3015107799151348`*^-6, 1.356923547998796`*^-6, 
      1.5097518420472716`*^-6, 1.7830957078806925`*^-6, 
      1.5201974702266658`*^-6, 0.`, 8.051709774674416`*^-7, 
      1.2786049597594756`*^-6, 1.5126152981288356`*^-6, 
      1.604650880268812`*^-6, 1.3022065256799316`*^-6, 8180.898436560402`, 
      0.00003626464554422038`, 8.330929189676555`*^-6, 5619.039061277168`, 
      1528.5895673621767`, 1.243508851730933`*^-6, 7.461754474867671`*^-7, 
      1410.849607640154`, 862.7497544674792`, 452.68969530696086`, 
      8363.5976541265`, 5298.296873468247`, 0.`, 1354.0097651294561`, 
      21930.894528719247`, 9177.624998362362`, 13369.578128298484`, 
      416.14990056383743`, 5.541285321306161`*^-6, 2.2322707780440443`*^-6, 
      1.3526955581314764`*^-6, 3.7606513041670254`*^-6, 
      1.5687721850916423`*^-6, 6.183072999302453`*^-7, 
      6.093918878896726`*^-7, 0.00009217253827686358`, 
      0.00003207903417329248`, 9.292110873745694`*^-6, 
      5.8260170822036705`*^-6, 1.2862665450449647`*^-6, 0.`, 
      3.3712749451553288`*^-6, 1.540882818821178`*^-6, 
      0.000028816355914506888`, 5035.292952580589`, 3.885360024135265`*^-6, 
      2.9512687881169524`*^-10, 2.6306058335127616`*^-10, 
      2.9107240638675156`*^-7, 1.957245125926271`*^-8, 
      1.2446451674376596`*^-10, 0.018223791672426704`, 4.5897568111436`*^-7, 
      6.490256690849946`*^-7, 2.34618360378295`, 1.7865101473625676`*^-8, 
      4.684021910965791`*^-9, 0.3289668918777676`, 0.12078919982401905`, 
      0.15587319975312836`, 1.6542467288344445`*^-10, 
      1.3156119982710523`*^-9, 1.0376636164897713`*^-9, 
      1.7953504179274587`*^-10, 7.563157460962755`*^-9, 
      6.2604456037465335`*^-9, 1.1897757021875748`*^-8, 
      2.0547135903512302`*^-8, 1.218964842554501`*^-8, 
      1.3837395402881477`*^-8, 1.4903798440207967`*^-8, 
      2.3285635333802278`*^-8, 2.0684631349346577`*^-8, 
      3.0264868292801487`*^-8, 2.1790545561940772`*^-8, 
      6.136589004237006`*^-9, 7.991673923944003`*^-9, 6.63238260160186`*^-8, 
      5.4073557331605715`*^-9, 6.254033741545773`*^-8, 90.21659722630848`, 
      11.588019493554055`, 6.842255696606104`*^-11, 7.001568592260359`*^-11, 
      1.7088854696649348`*^-7, 1.403975277852025`*^-8, 
      2.7890580321095066`*^-11, 1.0503181006833378`*^-8, 
      3.162634756888525`*^-7, 29.99999926828646`, 2.0205339243647347`*^-10, 
      5.246391976625315`, 1.1114296055351689`*^-9, 3.2445355078285526`*^-11, 
      4.397352347354622`*^-11, 7.287757680950506`*^-11, 
      1.3817872423042884`*^-11, 0.6629056526801513`, 6.995488178359411`*^-11, 
      4.813932376268007`*^-11, 9.78945183029757`*^-9, 8.600643706144457`, 
      1.6005759970756754`, 8.537407133841112`, 12.093120108110332`, 
      3.92685435306339`, 2.831240346849711`, 10.150114676902787`, 
      9.304830950370684`, 2.6426069375803802`, 2.5507110953414522`, 
      21.567093218313396`, 9.268972813388494`, 25.56106115447301`, 
      24.08262697000318`, 48.95831794768153`, 15.674974107284296`, 
      4.040823538786865`*^-8, 1.1930021221042097`*^-7, 4.358714551768658`, 
      2.098321378512049`, 60.339839643581215`, 10.248594888283682`, 
      3.645962011196134`, 179.61421740897092`, 0.`, 3.0547949265882033`, 
      762.7621609172484`, 951.2949804514998`, 8.373060015940046`*^-11, 
      57.8168027970606`, 9.998902748850491`*^-6, 7.042739799601345`*^-12, 
      9.263665079042192`*^-12, 3.7762904387541`*^-12, 
      4.529086824763111`*^-12, 12.283878011100118`, 0.4555199999537107`, 
      0.044519999429814265`, 0.7049999997774474`, 4.581642746044899`*^-11, 
      1.2852456806015266`*^-11, 1268.9999999829956`, 55.41299999390837`, 
      6.728183188670828`*^-12, 4.393462018917897`*^-12, 
      3.2161797061597858`*^-12, 2.5225644890908693`*^-12, 0.`, 
      2.884373008104892`*^-10, 5.123449069378158`, 2.905879733821684`*^-10, 
      8.027210749424892`, 0.6676016829074571`, 5.2098168028772943`*^-11, 
      7.843665330365117`*^-12, 951.9999999974938`, 183.59046282637354`, 
      3.5292223626047704`*^-12, 2.1598881114956058`*^-12, 
      1.5272110969405846`*^-12, 1.1727409082052535`*^-12, 
      9.491671414865405`*^-13, 0.`, 7.894389901558871`, 7.865592048665918`, 
      131.1829851853223`, 6.79409449414977`*^-11, 1.0505469365179496`*^-10, 
      8.760772463673492`*^-11, 3.765710328821867`*^-11, 3.3789186142390886`, 
      6.171943868111491`*^-8, 1.0512328505241637`*^-8, 
      1.619749803032615`*^-8, 7.921235360570798`*^-10, 1541.7996109015653`, 
      3.2189795837863905`*^-8, 1.3487679084368103`*^-10, 
      2.49422418648787`*^-10, 0.835190679204461`, 0.16480932023571188`, 
      5.686675372400334`*^-11, 1.395814565560591`*^-11, 0.`, 
      19.947999392982407`, 6.9999999994812505`, 4.999999999940019`, 0.`, 
      7.491985160249384`*^-11, 1.3127928416132861`*^-10, 
      1.0408690449188273`*^-10, 4.12039067617105`*^-11, 
      0.012068999954206698`, 7.863315999984878`, 6.487500473856926`, 
      39.032116398215294`, 15.659634470939636`, 127.95093029737473`, 
      1.642219164206025`*^-10, 1.62401573648407`*^-10, 
      3.873481659575595`*^-7, 8.589737189775941`*^-8, 
      2.698280966470481`*^-10, 3.253242948892458`*^-9, 
      7.501881016970107`*^-7, 1.1653990560648241`*^-6, 1.8769468838938665`, 
      1.4614127738930723`*^-8, 7.98992508780137`*^-9, 0.1285715136908977`, 
      0.056384360120073904`, 0.072761560231167`, 2.2032937458883334`*^-10, 
      1.100373489393991`*^-9, 2.1176756452063787`*^-10, 
      1.344195856684899`*^-10, 113.37439791858196`, 16.952837020158768`, 
      104.60214978456497`, 162.20946472883224`, 45.907443195581436`, 
      32.07089510560036`, 111.27135793864727`, 108.50372356176376`, 
      30.54210539162159`, 29.928266286849976`, 251.9666619747877`, 
      110.808772534132`, 315.6926720738411`, 299.34800659120083`, 
      596.2308561950922`, 175.68469904363155`, 191.02565968036652`, 
      261.49634808301926`, 915.7292769036615`, 24.963886779679864`, 
      3736.1455606042036`, 317.0254756639514`, 310.0697932597758`, 
      96137.0345354388`, 96137.0345361706`, 1.4669988469578314`*^-6, 
      0.000013979271557138781`, 2567.0305119899353`, 1.8025679372338359`*^-6, 
      0.000012694721853980811`, 648.3366685781014`, 8143.679687065168`, 
      1.3889847772131407`*^-6, 1.537604665512018`*^-6, 
      1.5142124884564007`*^-6, 1.7633570599139199`*^-6, 
      2.1503709472875604`*^-6, 0.`, 8.560009829559489`*^-7, 
      1.4406430256851121`*^-6, 1.5722516465745673`*^-6, 
      1.8294064410241972`*^-6, 1.4960983578728196`*^-6, 9913.792967097552`, 
      0.000042832217932489674`, 6.420302460040404`*^-6, 6809.277342017046`, 
      1852.3791324085787`, 1.6340081753705255`*^-6, 9.669260300315194`*^-7, 
      1709.6992175277833`, 1045.4995101684665`, 548.5795882315686`, 
      10135.19530810132`, 6420.59374781836`, 0.`, 1640.819335068019`, 
      26576.34765855615`, 11121.652338250578`, 16201.550778021361`, 
      504.29980330601956`, 3.26343008853755`*^-6, 2.338392949665515`*^-6, 
      1.3434508200069546`*^-6, 3.3227035298095813`*^-6, 
      1.7732182664598305`*^-6, 7.240677784024464`*^-7, 
      7.561780022204281`*^-7, 0.00003279319759922157`, 
      0.0000101661312173595`, 0.00001030886974795944`, 
      6.958947524670696`*^-6, 1.1023103789363568`*^-6, 0.`, 
      3.2785016665265965`*^-6, 1.48548109923151`*^-6, 
      0.000024597886744144396`, 2317.1361770034214`, 3.106199891255919`*^-6, 
      1.642219164206025`*^-10, 1.62401573648407`*^-10, 
      3.873481659575595`*^-7, 8.589737189775941`*^-8, 
      2.698280966470481`*^-10, 3.253242948892458`*^-9, 
      7.501881016970107`*^-7, 1.1653990560648241`*^-6, 1.8769468838938665`, 
      1.4614127738930723`*^-8, 7.98992508780137`*^-9, 0.1285715136908977`, 
      0.056384360120073904`, 0.072761560231167`, 2.2032937458883334`*^-10, 
      1.100373489393991`*^-9, 2.1176756452063787`*^-10, 
      1.344195856684899`*^-10, 5.906859079272774`*^-9, 
      5.019104193450156`*^-9, 9.237008250149523`*^-9, 
      1.6246399267596148`*^-8, 9.473984945806138`*^-9, 
      9.017615311696572`*^-9, 7.567884396149694`*^-9, 1.842837062054513`*^-8, 
      1.292999171489609`*^-8, 2.1647060348641052`*^-8, 
      1.6410663556161194`*^-8, 4.746037162602278`*^-9, 
      6.080367087672377`*^-9, 5.22320732781583`*^-8, 4.197060845947131`*^-9, 
      2.6059310916112555`*^-8, 1.345913434382777`*^-8, 
      2.861096609978747`*^-8, 0.7828836868539616`, 0.9623697491225737`, 
      6.397680471464359`*^-7, 3.914146467254991`*^-8, 
      2.2957357331848274`*^-10, 0.46894449041394004`, 9.299480021490215`*^-7, 
      510.07828971330355`, 9.67277453150977`*^-10, 7.329160823099165`*^-8, 
      5.103841637567704`*^-9, 2.5101770045389646`*^-10, 
      3.415908120180369`*^-10, 5.682513890925644`*^-10, 
      1.2212995944033135`*^-10, 5.661313537177824`*^-9, 
      4.3704947700922765`*^-7, 0.043999948308724265`, 5.932856296798892`*^-9, 
      8.867263700150552`, 1.6501938788231494`, 8.802066814630775`, 
      12.468006934608107`, 4.04858689456119`, 2.9190088593729766`, 
      10.464768292788225`, 9.593280822704221`, 2.724527787911788`, 
      2.6297832068771356`, 22.235673215761217`, 9.556311002414043`, 
      26.353454091740787`, 24.829188722927398`, 50.476025832854546`, 
      16.16089889985906`, 13.733566911289733`, 
      108.51179640033052`}\)], "Output"],

Cell[BoxData[
    \(\(-2581.139266151793`\)\)], "Output"],

Cell[BoxData[
    \(0.0017101880997092548`\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"Export", "[", 
      RowBox[{
        RowBox[{"rootDir", " ", "<>", 
          StyleBox["\"\<sol\>\"",
            "MR"], 
          StyleBox[" ",
            "MR"], 
          StyleBox["<>",
            "MR"], "problemId", "<>", " ", 
          StyleBox["\"\<.txt\>\"",
            "MR"]}], 
        StyleBox[",",
          "MR"], " ", Cell[BoxData[
            FormBox[
              StyleBox["mySol",
                "MR"], TraditionalForm]]], ",", " ", "\"\<Lines\>\""}], 
      "]"}]], "Input"],

Cell[BoxData[
    \("D:\\DATADIR\\Programmazione\\java\\joptimizer\\src\\test\\resources\\\
lp\\standardization\\sol5.txt"\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"Export", "[", 
      RowBox[{
        RowBox[{"rootDir", " ", "<>", 
          StyleBox["\"\<value\>\"",
            "MR"], 
          StyleBox[" ",
            "MR"], 
          StyleBox["<>",
            "MR"], "problemId", "<>", " ", 
          StyleBox["\"\<.txt\>\"",
            "MR"]}], 
        StyleBox[",",
          "MR"], " ", Cell[BoxData[
            FormBox[
              StyleBox["myValue",
                "MR"], TraditionalForm]]], ",", " ", "\"\<Lines\>\""}], 
      "]"}]], "Input"],

Cell[BoxData[
    \("D:\\DATADIR\\Programmazione\\java\\joptimizer\\src\\test\\resources\\\
lp\\standardization\\value5.txt"\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"Export", "[", 
      RowBox[{
        RowBox[{"rootDir", " ", "<>", 
          StyleBox["\"\<tolerance\>\"",
            "MR"], 
          StyleBox[" ",
            "MR"], 
          StyleBox["<>",
            "MR"], "problemId", "<>", " ", 
          StyleBox["\"\<.txt\>\"",
            "MR"]}], 
        StyleBox[",",
          "MR"], " ", Cell[BoxData[
            FormBox[
              StyleBox["myTolerance",
                "MR"], TraditionalForm]]], ",", " ", "\"\<Lines\>\""}], 
      "]"}]], "Input"],

Cell[BoxData[
    \("D:\\DATADIR\\Programmazione\\java\\joptimizer\\src\\test\\resources\\\
lp\\standardization\\tolerance5.txt"\)], "Output"]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"5.0 for Microsoft Windows",
ScreenRectangle->{{0, 1920}, {0, 993}},
WindowSize->{1912, 961},
WindowMargins->{{0, Automatic}, {Automatic, 0}}
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 95, 5, 138, "Subtitle"],
Cell[1874, 60, 213, 4, 50, "Input"],

Cell[CellGroupData[{
Cell[2112, 68, 4520, 148, 233, "Input"],
Cell[6635, 218, 38, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6710, 224, 361, 9, 70, "Input"],
Cell[7074, 235, 27890, 416, 1017, "Output"],
Cell[34967, 653, 57, 1, 29, "Output"],
Cell[35027, 656, 56, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[35120, 662, 526, 17, 31, "Input"],
Cell[35649, 681, 136, 2, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[35822, 688, 530, 17, 31, "Input"],
Cell[36355, 707, 138, 2, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[36530, 714, 538, 17, 31, "Input"],
Cell[37071, 733, 142, 2, 29, "Output"]
}, Open  ]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

